Option Explicit

Global Const CANCELAR = 2, SI = 6, NO = 7
Global Const PI = 3.141593
Global Boton As Integer
Global MsgError As String
'Unidades de la estructura
Global UdsLong As String
Global UdsFuer As String

'Ruta del programa
Global RutaActual As String

'Para el botn de denes BotonStop
Global AbortarCalculo As Integer

'Para guardar las barras
Type Estructura
    NudoI As Integer
    NudoJ As Integer
    Xi As Single
    Yi As Single
    Xj As Single
    Yj As Single
    Area As Single
    Inercia As Single
End Type

'La siguiente matriz de estructuras Barra contendr a todas las lneas de la
'estructura pefectamente definidas (dentro de Barra estn los Registros
'Nudoi, Nudoj, Xi, Yi, Xj, Yj, que son la numeracin de los nudos y las
'coordenadas generales de la lnea) La matriz ha de ser esttica en vez de
'dinmica ya que as lo exijen las matrices de estructuras (Type).
Global Barra(200) As Estructura

Global Longitud As Single

'Longitudes de las barras y coordenadas de sus nudos
Global MatrizLongitudes() As Single, X() As Single, Y() As Single
'Datos de la barra seleccionada en General.ListaBarras
Dim sena As Single, cosa As Single
Dim CargaB() As Single, CargaN() As Single

'Puntos que definen la lnea sealadora de la abscisa anterior
Dim XpA As Single, YpA As Single, XqA As Single, YqA As Single
'Puntos que definen la lnea sealadora de la abscisa Nueva
Dim XpN As Single, YpN As Single, XqN As Single, YqN As Single

'Resultados de la matrz de rigidez
Global Normales() As Single, Cortantes() As Single, Flectores() As Single

'Matrices que contienen las ecuaciones de las grficas
Global EcNor() As String, EcCor() As String, EcFle() As String
Global EcGir() As String, EcDef() As String, Inercia() As Single
Global EcDefX() As String, EcDefY() As String
Global Valores() As Single, Movimientos() As Single

'Para la funcin GetCursorPos
Type POINTAPI
    X As Integer
    Y As Integer
End Type

Global Const KEY_ESCAPE = &H1B

'Funcin API para rellenar un rea con un color
Declare Function FloodFill Lib "GDI" (ByVal hDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal crColor As Long) As Integer

Global Const SWP_NOMOVE = &H2
Global Const SWP_NOSIZE = &H1
Global Const Flags = SWP_NOMOVE Or SWP_NOSIZE
Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2

'Funcin API para mantener un formulario flotante
Declare Sub SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer)
				       
'Para imprimir imgenes sueltas
Declare Function CreateCompatibleDC Lib "GDI" (ByVal hDC As Integer) As Integer

Declare Function SelectObject Lib "GDI" (ByVal hDC As Integer, ByVal hObject As Integer) As Integer

Declare Function StretchBlt% Lib "GDI" (ByVal hDC%, ByVal X%, ByVal Y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal XSrc%, ByVal YSrc%, ByVal nSrcWidth%, ByVal nSrcHeight%, ByVal dwRop&)

Declare Function DeleteDC Lib "GDI" (ByVal hDC As Integer) As Integer

Sub AbrirFichero (Fichero As String)
    Dim Msg As String
    
    GeneralNuevo
    
    On Error GoTo Problemas2
    
    'Ponemos el nombre del fichero al formulario
    General.Caption = Left$(General.Caption, 11) & Fichero
    'Llenamos la lista de barras
    LlenaListaBarras Fichero
    'Llenamos la caja de cargas con la estructura y las cargas
    DibujaEstructura General!GrafCargas, "Papel"
    DibujaCargas "Papel"
    If General!BotonVerNum.Tag = "SI" Then DibujaNumerosNudos General!GrafCargas, "Papel"
    DibujaApoyos General!GrafCargas, "Papel"
    'Llenamos las dems cajas con la estructura
    DibujaEstructura General!GrafGiros, "Papel"
    If General!BotonVerNum.Tag = "SI" Then DibujaNumerosNudos General!GrafGiros, "Papel"
    DibujaEstructura General!GrafNormales, "Papel"
    If General!BotonVerNum.Tag = "SI" Then DibujaNumerosNudos General!GrafNormales, "Papel"
    DibujaEstructura General!GrafCortantes, "Papel"
    If General!BotonVerNum.Tag = "SI" Then DibujaNumerosNudos General!GrafCortantes, "Papel"
    DibujaEstructura General!GrafFlectores, "Papel"
    If General!BotonVerNum.Tag = "SI" Then DibujaNumerosNudos General!GrafFlectores, "Papel"
    DibujaEstructura General!GrafDeflexiones, "Papel"
    If General!BotonVerNum.Tag = "SI" Then DibujaNumerosNudos General!GrafDeflexiones, "Papel"

    'Activamos el botn de dibujo de las grficas e impresin
    General!BINno.Tag = ""
    General!BotonInicio.Picture = General!BINup.Picture
    General!OpcionInicio.Enabled = True
    General!BIno.Tag = ""
    General!BotonImprimir.Picture = General!BIup.Picture
    General!ArchivoImprimir.Enabled = True
    
    Exit Sub

Problemas2:
    Close
    Screen.MousePointer = 1
    If MsgError = "" Then
	MsgError = "El fichero no tiene la estructura de datos esperada"
    End If
    MsgBox MsgError, 48, "Atencin!"
    MsgError = ""
    Exit Sub

End Sub
    

Sub ActualizaAbscisa ()
    Dim Num As String, GrisO As Long

    GrisO = &H808080
	
    If General.Visible Then
	If FormValores.Visible Then
	    'Si estbamos viendo los valores de las abscisas mviles
	    General!OpcionValores.Checked = False
	    'Ponemos el formulario de Valores en 2 plano
	    FormValores.Hide
	    SetWindowPos FormValores.hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, Flags
	    'Lo descargamos
	    Unload FormValores
	    'Ponemos a cero los puntos de la abscisa mvil
	    XpA = 0: YpA = 0: XqA = 0: YqA = 0
	    'Eliminamos las abscisas
	    DibujaAbscisa General!GrafCargas, -1
	    DibujaAbscisa General!GrafGiros, -1
	    DibujaAbscisa General!GrafNormales, -1
	    DibujaAbscisa General!GrafCortantes, -1
	    DibujaAbscisa General!GrafFlectores, -1
	    DibujaAbscisa General!GrafDeflexiones, -1
	    XpN = 0: YpN = 0: XqN = 0: YqN = 0
	    'Desactivamos la caja de abscisas
	    General!Label1.ForeColor = GrisO: General!Label2.ForeColor = GrisO
	    General!ActualX.Text = "": General!IncrementoX.Text = ""
	    General!ActualX.Enabled = False: General!Spin1.Enabled = False
	    General!IncrementoX.Enabled = False: General!Spin1.ForeColor = GrisO
	    'Activamos la lista de barras
	    General!ListaBarras.Enabled = True
	    General!Label3.ForeColor = RGB(0, 0, 0)
	Else
	    General!OpcionValores.Checked = True
	    FormValores.Show
	    ActualizaUnidades
	    'Ponemos el formulario de Valores en 1 plano (flotante)
	    SetWindowPos FormValores.hWnd, HWND_TOPMOST, 0, 0, 0, 0, Flags
	    'Activamos la caja de abscisas
	    General!Label1.ForeColor = 0: General!Label2.ForeColor = 0
	    General!ActualX.Enabled = True: General!Spin1.Enabled = True
	    General!IncrementoX.Enabled = True: General!Spin1.ForeColor = 0
	    'Actualizamos el contenido de las cajas de la abscisa
	    General!ActualX.Text = "0"
	    General!ActualX.Tag = General!ActualX.Text
	    'Colocamos como valor inicial para los incrementos de las
	    'abscisas el 5% de la longitud de la barra
	    Num = Str$(.05 * MatrizLongitudes(General!ListaBarras.ListIndex))
	    Formatea Num
	    If Val(Num) = 0 And UdsLong = "M" Then Num = ".01"
	    If Val(Num) = 0 And UdsLong = "C" Then Num = "1"
	    General!IncrementoX.Text = Num
	    General!IncrementoX.Tag = General!IncrementoX.Text
	    'Dibujamos la 1 abscisa mvil
	    CalculaAbscisa
	    'Actualizamos las cifras del formulario Valores
	    ActualizaValores
	    'Desactivamos la lista de barras
	    General!ListaBarras.Enabled = False
	    General!Label3.ForeColor = GrisO
	End If
    End If

End Sub

Sub ActualizaUnidades ()
    Dim L As String, F As String

    F = "k"
    If UdsFuer = "T" Then F = "t"
    L = "m"
    If UdsLong = "C" Then L = "cm"
    
    FormValores!UniPx.Caption = F
    FormValores!UniPy.Caption = F
    FormValores!UniMz.Caption = L & "*" & F
    FormValores!UniN.Caption = F & "/" & L & "^2"
    FormValores!UniV.Caption = F & "/" & L & "^2"
    FormValores!UniM.Caption = L & "*" & F
    FormValores!UniDx.Caption = L
    FormValores!UniDy.Caption = L

End Sub

Sub ActualizaValores ()
    
    ActualizaValoresCargas
    ActualizaValoresNormales
    ActualizaValoresCortantes
    ActualizaValoresFlectores
    ActualizaValoresGiros
    ActualizaValoresDeflexiones

End Sub

Sub ActualizaValoresCargas ()
    Dim I As Integer, SAng As Single, CAng As Single, Carga As Single
    Dim LongA As Single, LongB As Single, Angulo As Single, Tipo As Single
    Dim Px As Single, Py As Single, Mz As Single, X As Single

    X = Val(General!ActualX.Text)
    
    'El orden de los componentes en la matrz de cargas en barra es: valor de
    'la carga, long. A, Long. B, ngulo y tipo
    For I = 1 To CargaB(0)
	Carga = CargaB((I - 1) * 5 + 1)
	LongA = CargaB((I - 1) * 5 + 2)
	LongB = CargaB((I - 1) * 5 + 3)
	Angulo = CargaB((I - 1) * 5 + 4)
	Angulo = Angulo * PI / 180
	CAng = Cos(Angulo)
	SAng = Sin(Angulo)
	If Abs(CAng) < .001 Then CAng = 0
	If Abs(SAng) < .001 Then SAng = 0
	Tipo = CargaB((I - 1) * 5 + 5)
	Select Case Tipo
	    Case 1
		'Carga puntual
		If X = LongA Then
		    Px = Px + Carga * CAng
		    Py = Py + Carga * SAng
		End If
	    Case 2
		'Carga repartida
		If X >= LongA And X <= (LongA + LongB) Then
		    Px = Px + Carga * CAng
		    Py = Py + Carga * SAng
		End If
	    Case 3
		'Triangular con pendiente positiva
		If X >= LongA And X <= (LongA + LongB) Then
		    Carga = Carga * (X - LongA) / LongB
		    Px = Px + Carga * CAng
		    Py = Py + Carga * SAng
		End If
	    Case 3
		'Triangular con pendiente negativa
		If X >= LongA And X <= (LongA + LongB) Then
		    Carga = Carga * (LongA + LongB - X) / LongB
		    Px = Px + Carga * CAng
		    Py = Py + Carga * SAng
		End If
	    Case Else
		'Los flectores ya vienen con el signo (horario positivo)
		If X = LongA Then Mz = Mz + Carga
	End Select
    Next I
    
    'Las cargas en los nudos: esta matrz tiene 7 componentes, CargaN(0) nos
    'dice las cargas del nudo, si es 0 no tiene, 1 tiene el nudo i, 2 el j
    'y si vale 3 tiene ambos nudos. Las componentes del nudo i son los
    'elementos 1, 2, y 3, los del j el 4, 5 y 6
    If X = 0 And CargaN(0) = 1 Or CargaN(0) = 3 Then
	'Si el nudo i tiene carga
	Px = Px + CargaN(1)
	Py = Py + CargaN(2)
	Mz = Mz + CargaN(3)
    End If
    If X = MatrizLongitudes(General!ListaBarras.ListIndex) And CargaN(0) = 2 Or CargaN(0) = 3 Then
	'Si el nudo j tiene carga
	Px = Px + CargaN(4)
	Py = Py + CargaN(5)
	Mz = Mz + CargaN(6)
    End If

    FormValores!CargaPx.Caption = Px
    FormValores!CargaPy.Caption = Py
    FormValores!CargaMz.Caption = Mz

End Sub

Sub ActualizaValoresCortantes ()
    Dim Num As Single, X As Single

    X = Val(General!ActualX.Text)
    Num = Valor(EcCor(General!ListaBarras.ListIndex), X)

    Num = Format(Num, "0.###")
    FormValores!Cortantes.Caption = LTrim(Str$(Num))
    
End Sub

Sub ActualizaValoresDeflexiones ()
    Dim Num As Single, XBarra As Single, X As Single, Y As Single
    Dim iba As Integer, Incr As Single, NudoI As Integer, NudoJ As Integer
    
    iba = General!ListaBarras.ListIndex
    NudoI = Val(Left$(General!ListaBarras.List(iba), InStr(1, General!ListaBarras.List(iba), "-") - 1))
    NudoJ = Val(Mid$(General!ListaBarras.List(iba), InStr(1, General!ListaBarras.List(iba), "-") + 1))
    
    XBarra = Val(General!ActualX.Text)

    Incr = IncrementoLongBarra(XBarra, iba, NudoI, NudoJ)

    Num = -Valor(EcDef(iba), XBarra)
    
    X = Incr * cosa + Movimientos(NudoI, 1) - (Num * sena) / Inercia(iba)
    Y = Incr * sena + Movimientos(NudoI, 2) + (Num * cosa) / Inercia(iba)
    X = Format(X, "0.#####")
    Y = Format(Y, "0.#####")
    
    FormValores!MovimientoX.Caption = LTrim(Str$(X))
    FormValores!MovimientoY.Caption = LTrim(Str$(Y))

End Sub

Sub ActualizaValoresFlectores ()
    Dim Num As Single, X As Single

    X = Val(General!ActualX.Text)
    Num = Valor(EcFle(General!ListaBarras.ListIndex), X)

    Num = Format(Num, "0.###")
    FormValores!Flectores.Caption = LTrim(Str$(Num))

End Sub

Sub ActualizaValoresGiros ()
    Dim Num As Single, X As Single

    X = Val(General!ActualX.Text)
    Num = Valor(EcGir(General!ListaBarras.ListIndex), X)
    Num = Num / Inercia(General!ListaBarras.ListIndex)
    Num = Format(Num, "0.#####")
    FormValores!Giros.Caption = LTrim(Str$(Num))

End Sub

Sub ActualizaValoresNormales ()
    Dim Num As Single, X As Single

    X = Val(General!ActualX.Text)
    Num = Valor(EcNor(General!ListaBarras.ListIndex), X)

    Num = Format(Num, "0.###")
    FormValores!Normales.Caption = LTrim(Str$(Num))

End Sub

Sub CalculaAbscisa ()
    'Dibuja una lnea, normal a la barra, que marca la abscisa actual que
    'aparece en Actual.text

    Dim X As Single, Xp1 As Single, Yp1 As Single
    Dim Extremo As Single, XY As String, Pos As Integer
    
    ReDim Puntos(8)
    X = Val(General!ActualX.Text)
    
    'Necesitamos los dos ptos que la definen, uno por arriba de la barra y
    'el otro por debajo.
    'Obtenemos las coordenadas en ejes generales del punto P1 en el que
    'deseamos dibujar la abscisa
    Xp1 = Barra(1).Xi + X * cosa
    Yp1 = Barra(1).Yi + X * sena
    'La lnea tendr una longitud del 10% de la altura de GrafCargas
    Extremo = .05 * Abs(General!GrafCargas.ScaleHeight)
    'Le sumamos PI/2 al ngulo de la barra para que la lnea sea normal a la
    'barra, el punto por debajo ser
    XpN = Xp1 - Extremo * sena
    YpN = Yp1 + Extremo * cosa
    'El punto por encima
    XqN = Xp1 + Extremo * sena
    YqN = Yp1 - Extremo * cosa
    
    'Dibujamos las lneas
    DibujaAbscisa General!GrafCargas, 0
    DibujaAbscisa General!GrafGiros, 0
    DibujaAbscisa General!GrafNormales, 0
    DibujaAbscisa General!GrafCortantes, 0
    DibujaAbscisa General!GrafFlectores, 0
    DibujaAbscisa General!GrafDeflexiones, 0

    'Actualiza las coordenadas
    XpA = XpN: YpA = YpN
    XqA = XqN: YqA = YqN
	
End Sub

Function CalcularMaxCargas ()
    'Abrimos el fichero de datos y, en funcin de las barras seleccionadas en
    'la lista de barras, recorremos las barras y nudos para ver qu carga
    'arroja las diferencias mximas de sus coordenadas
    
    Dim DifX As Single, DifY As Single, Maximos() As Single, Max As Single
    Dim Nbar As Integer, NNud As Integer, Puntos() As Single
    Dim Ini As Integer, CadN As String
    Dim I As Integer, Pos As Integer, CadVar As String, Nudo As Integer
    Dim X As Single, Y As Single, Acumula As Integer, NudoIni As Integer
    Dim Abscisas() As Single, Ordenadas() As Single, NudoFin As Integer
    Dim BarraIni As Integer, BarraFin As Integer
    
    
    ReDim Maximos(2)
    'Los componentes de Puntos sern las coordenadas de los 4 puntos que
    'definen a una carga repartida:
    '
    '        Xq1,Yq1 ----------------Xq2,Yq2
    '           |                       |
    '           |                       |
    '           |                       |
    '        Xp1,Yp1                 Xp2,Yp2
    'siendo el orden p1,q1,p2,q2. Si la carga es puntual slo aparecern
    'P1 y P2 y si es un flector slo p1. En Puntos(0) vendr el signo del
    'flector (+1, -1)
    
    Open Mid$(General.Caption, 12) For Binary As #1
    Get #1, 1, Ini  'Inicio de los datos de dibujo
    Ini = Ini - 1
    Get #1, 15, NNud
    Get #1, 17, Nbar

    'Llenamos las matrices de abscisas y ordenadas de los nudos
    ReDim Abscisas(NNud)
    ReDim Ordenadas(NNud)
    'Las abscisas empiezan en la posicin 41
    Seek #1, 41
    For I = 1 To NNud
	Get #1, , Abscisas(I)
    Next I
    'El inicio de las ordenadas se guarda en la posicin 3 y 4
    Get #1, 3, Pos
    Seek #1, Pos
    For I = 1 To NNud
	Get #1, , Ordenadas(I)
    Next I
    'Tomamos los datos dependiendo de la barra a dibujar
    Pos = General!ListaBarras.ListIndex
    If Pos = 0 Then
	BarraIni = 1
	BarraFin = Nbar
    Else
	'Tomamos el n de los nudos que son los que aparecen en la lista de
	'barras
	NudoIni = Val(Left$(General!ListaBarras.List(Pos), InStr(1, General!ListaBarras.List(Pos), "-") - 1))
	NudoFin = Val(Mid$(General!ListaBarras.List(Pos), InStr(1, General!ListaBarras.List(Pos), "-") + 1))
	'La barra que hemos elegido es:
	BarraIni = General!ListaBarras.ListIndex
	BarraFin = BarraIni
	'Localizamos el inicio de su carga
	For I = 1 To BarraFin - 1
	    'De la posicin 17 obtenemos el inicio de las cargas en barras
	    Pos = Ini + 17
	    Seek #1, Pos
	    Get #1, , Pos
	    'Vamos hasta all, Acumula= long. de todas las cargas anteriores
	    Seek #1, Ini + Pos + Acumula
	    'Obtenemos la longitud de la carga
	    Get #1, , Pos
	    'La guardamos en Acumula para conocer el inicio de la prxima, en
	    'Pos est la longitud de la carga y el 2 son los by que ocupan la
	    'longitud de la cadena de la carga que hay al ppo. de cada carga
	    Acumula = Acumula + Pos + 2
	Next I
    End If

    For I = BarraIni To BarraFin
	'De la posicin 17 obtenemos el inicio de las cargas en barras
	Pos = Ini + 17
	Seek #1, Pos
	Get #1, , Pos
	'Vamos hasta all, Acumula= long. de todas las cargas anteriores
	Seek #1, Ini + Pos + Acumula
	'Obtenemos la longitud de la carga
	Get #1, , Pos
	'La guardamos en Acumula para conocer el inicio de la prxima, en Pos
	'est la longitud de la carga y el 2 son los by de la longitud de
	'la cadena de la carga
	Acumula = Acumula + Pos + 2
	'Obtenemos la carga
	CadVar = Space$(Pos)
	Get #1, , CadVar
	'Si la carga no existe, probamos con la sig. barra
	If CadVar <> "" Then
	    'Tomamos la barra, empiezan en la posicin 27 relativa a Ini y
	    'cada una ocupa 28 by
	    Pos = Ini + 27 + (I - 1) * 28
	    Get #1, Pos, Barra(1)
	    'Hacemos un bucle para obtener los ptos. de cada una de las cargas
	    Do
		ReDim Puntos(8)
		'Hallamos el final de la carga actual
		Pos = InStr(1, CadVar, "/")
		'Obtenemos la carga actual y se la quitamos a la cadena general
		CadN = Left$(CadVar, Pos - 1)
		CadVar = Mid$(CadVar, Pos + 1)
		'Miramos que no sea un flector, que no influyen
		If Left$(CadN, 1) <> "M" Then
		    'Obtenemos los puntos
		    DamePuntos Puntos(), Barra(1), CadN, 1
		    'Si alguna diferencia de los puntos supera a las guardadas
		    'la cambiamos
		    'Hallamos la dif entre las coord. Xq1 - Xp1
		    DifX = Abs(Puntos(3) - Puntos(1))
		    If DifX > Maximos(1) Then Maximos(1) = DifX
		    'Hallamos la dif entre las coord. Yq2 - Yp2
		    DifX = Abs(Puntos(5) - Puntos(7))
		    If DifX > Maximos(1) Then Maximos(1) = DifX
		    'Hallamos la dif entre las coord. Xq2 - Xp2
		    DifY = Abs(Puntos(4) - Puntos(2))
		    If DifY > Maximos(2) Then Maximos(2) = DifY
		    'Hallamos la dif entre las coord. Yq2 - Yp2
		    DifY = Abs(Puntos(6) - Puntos(8))
		    If DifY > Maximos(2) Then Maximos(2) = DifY
		End If
	    Loop Until Len(CadVar) = 0
	End If
    Next I
    Acumula = 0
    
    'Los componentes de Puntos ahora sern las coordenadas del punto Q1
    'que definen a una carga puntual, ya que el P1 es el propio nudo
    '
    '        Xq1,Yq1
    '           |
    '           |
    '           |
    '        Xp1,Yp1
    'Si es un flector no lo tendremos en cuenta, ya que su radio es fijo
    Pos = Ini + 21
    Seek #1, Pos
    Get #1, , Pos
    'Colocamos el puntero en el comienzo de las cargas de nudos
    Pos = Ini + Pos
    Seek #1, Pos
    'Para obtener las cargas de los nudos
    For I = 1 To NNud
	'Obtenemos el n del nudo
	Get #1, , Nudo
	'Obtenemos la longitud de la carga
	Get #1, , Pos
	'Obtenemos la carga
	CadVar = Space$(Pos)
	Get #1, , CadVar
	If General!ListaBarras.ListIndex > 0 Then
	    'Si tenemos elegida una barra y este nudo no le pertenece,
	    'vaciamos la cadena de carga para que no se dibuje y pasar al
	    'siguiente nudo
	    If Nudo <> NudoIni And Nudo <> NudoFin Then
		CadVar = ""
	    End If
	End If
	'Si la carga no existe, probamos con el sig. nudo
	If CadVar <> "" Then
	    'La funcin que obtiene los ptos de trazado precisa como argumento
	    'un Type Barra, as que ponemos las coordenadas del nudo en l
	    Barra(0).Xi = Abscisas(Nudo)
	    Barra(0).Yi = Ordenadas(Nudo)
	    'Hacemos un bucle para obtener los ptos. de cada una de las cargas
	    Do
		ReDim Puntos(8)
		'Hallamos el final de la carga actual
		Pos = InStr(1, CadVar, "/")
		'Obtenemos la carga actual y se la quitamos a la cadena general
		CadN = Left$(CadVar, Pos - 1)
		CadVar = Mid$(CadVar, Pos + 1)
		'Miramos que no sea un flector, que no influyen
		If Left$(CadN, 1) <> "M" Then
		    'Obtenemos el punto extremo de la carga puntual
		    DamePuntos Puntos(), Barra(0), CadN, 1
		    'Si alguno de los puntos supera a los guardados, lo
		    'cambiamos
		    'Restamos la coord. X extremo de q1 de la de su origen
		    DifX = Abs(Puntos(3) - X)
		    If DifX > Maximos(1) Then Maximos(1) = DifX
		    'Restamos la coord. Y extremo de P1 de la de su origen
		    DifY = Abs(Puntos(4) - Y)
		    If DifY > Maximos(2) Then Maximos(2) = DifY
		End If
	    Loop Until Len(CadVar) = 0
	End If
    Next I
    
    Close #1

    If Maximos(1) > Maximos(2) Then
	Max = Maximos(1)
    Else
	Max = Maximos(2)
    End If
    
    CalcularMaxCargas = Max
    
End Function

Sub CargaGeneral ()
    Dim Fichero As String
    
    'Si venimos del formulario Diseo y hemos salvado la estructura
    'diseada en l, cargamos dicha estructura
    Fichero = Mid$(General.Caption, 12)
    AbrirFichero Fichero

End Sub

Sub DamePuntos (Puntos() As Single, Barra As Estructura, Carga As String, Escala As Single)
    Dim Xi As Single, Yi As Single, Xj As Single, Yj As Single
    Dim Nombre As String, LongA As Single, LongB As Single, Longi As Single
    Dim CargaP1 As Single, CargaP2 As Single, AngA As Single, AngB As Single
    Dim Pos As Integer, XY As String, CaD As String, Radio As Single
    Dim Xp1 As Single, Yp1 As Single, Xq1 As Single, Yq1 As Single
    Dim Xp2 As Single, Yp2 As Single, Xq2 As Single, Yq2 As Single
    
    
    'Las coordenadas de la barra son
    Xi = Barra.Xi
    Yi = Barra.Yi
    Xj = Barra.Xj
    Yj = Barra.Yj
    'El ngulo que forma la barra respecto a los ejes generales ser
    If Xj - Xi = 0 Then
	If Yj > Yi Then
	    AngB = PI / 2
	Else
	    AngB = 3 * PI / 2
	End If
    Else
	AngB = Atn((Yj - Yi) / (Xj - Xi))
    End If
    
    'La longitud de la barra y el radio de los momentos son
    Longi = Sqr((Xj - Xi) * (Xj - Xi) + (Yj - Yi) * (Yj - Yi))
    Radio = Longi * .1
    
    'Obtenemos el nombre y los dems datos de la carga
    Pos = InStr(1, Carga, " ")
    Nombre = Left$(Carga, Pos - 1)
    Carga = Mid$(Carga, Pos + 1)
	
    Pos = InStr(1, Carga, " ")
    CargaP1 = Val(Left$(Carga, Pos - 1))
    Carga = Mid$(Carga, Pos + 1)
	
    Pos = InStr(1, Carga, " ")
    CargaP2 = Val(Left$(Carga, Pos - 1))
    Carga = Mid$(Carga, Pos + 1)

    Pos = InStr(1, Carga, " ")
    LongA = Val(Left$(Carga, Pos - 1))
    Carga = Mid$(Carga, Pos + 1)
    
    Pos = InStr(1, Carga, " ")
    LongB = Val(Left$(Carga, Pos - 1))
    Carga = Mid$(Carga, Pos + 1)
    
    'Transformamos el ngulo para el dibujo
    AngA = Val(Carga) * PI / 180
    If AngA > PI Then
	AngA = AngA - PI
    Else
	AngA = AngA + PI
    End If
    
    'Obtenemos las coordenadas del punto P1
    XY = DameXY(AngB, LongA, Xi, Yi)
    Pos = InStr(1, XY, " ")
    Xp1 = Val(Left$(XY, Pos - 1))
    Yp1 = Val(Mid$(XY, Pos + 1))
	
    'Vemos si la carga es un momento o no
    If Left$(Nombre, 1) = "M" Then
	'Colocamos el signo en el radio
	If Left(Nombre, 8) = "MomentoH" Then
	    Puntos(0) = Radio
	Else
	    Puntos(0) = Radio * (-1)
	End If
    Else
	'Obtenemos las coordenadas del extremo de P1.
	CargaP1 = CargaP1 * Escala
	XY = DameXY(AngA, CargaP1, Xp1, Yp1)
	Pos = InStr(1, XY, " ")
	Xq1 = Val(Left$(XY, Pos - 1))
	Yq1 = Val(Mid$(XY, Pos + 1))
	'Si la carga es repartida
	If Left$(Nombre, 1) = "R" Then
	    'El origen de la carga P2 ser
	    XY = DameXY(AngB, LongA + LongB, Xi, Yi)
	    Pos = InStr(1, XY, " ")
	    Xp2 = Val(Left$(XY, Pos - 1))
	    Yp2 = Val(Mid$(XY, Pos + 1))
	    'El extremo
	    CargaP2 = CargaP2 * Escala
	    XY = DameXY(AngA, CargaP2, Xp2, Yp2)
	    Pos = InStr(1, XY, " ")
	    Xq2 = Val(Left$(XY, Pos - 1))
	    Yq2 = Val(Mid$(XY, Pos + 1))
	End If
    End If
    'Guardamos las soluciones
    Puntos(1) = Xp1: Puntos(2) = Yp1
    Puntos(3) = Xq1: Puntos(4) = Yq1
    Puntos(5) = Xp2: Puntos(6) = Yp2
    Puntos(7) = Xq2: Puntos(8) = Yq2
    
End Sub

Function DameXY (Ang As Single, Longi As Single, Xq As Single, Yq As Single)
    'Dadas las coordenadas polares de un Pto P respecto de otro Q de
    'coordenadas rectangulares X e Y, halla las rectangulares absolutas de P

    Dim CAng As Single, SAng As Single, Xp As String, Yp As String

    'Hallamos el seno y el coseno del ngulo
    CAng = Cos(Ang)
    SAng = Sin(Ang)
    If Abs(CAng) < .001 Then CAng = 0
    If Abs(SAng) < .001 Then SAng = 0

    Xp = LTrim(Str$(Xq + Longi * CAng))
    Yp = LTrim(Str$(Yq + Longi * SAng))

    DameXY = Xp + " " + Yp

End Function

Sub DibujaAbscisa (Papel As PictureBox, Selec As Integer)
    Dim ColorIni As Long, DMInicial As Integer, VerdeXor As Long

    VerdeXor = RGB(255, 0, 255)
    
    ColorIni = Papel.ForeColor
    Papel.ForeColor = Papel.BackColor
    DMInicial = Papel.DrawMode
    Papel.DrawMode = 7

    'Borra la abscisa mvil anterior si no se llam desde Seleccionar
    If Not Selec Then Papel.Line (XpA, YpA)-(XqA, YqA), VerdeXor

    'Establece la nueva lnea mvil
    Papel.Line (XpN, YpN)-(XqN, YqN), VerdeXor
	
    'Deja la pantalla con sus valores originales
    Papel.DrawMode = DMInicial
    Papel.ForeColor = ColorIni

End Sub

Sub DibujaApoyos (Papel As PictureBox, Donde As String)
    'Dispone el dibujo de los apoyos en el control Papel

    Dim Pos As Integer, NNud As Integer, Napo As Integer, I As Integer
    Dim X As Single, Y As Single, NudoIni As Integer, NudoFin As Integer
    Dim Ini As Integer, Ancho As Single, Alto As Single, Test As Integer
    Dim Nombre() As String, Nudo() As Integer
    Dim CadVar1 As String, CadVar2 As String
    
    Open Mid$(General.Caption, 12) For Binary As #1
    'El inicio de los datos de dibujo
    Get #1, 1, Ini
    Ini = Ini - 1
    'Obtenemos todos los nombres de los apoyos y los nudos en los que estn,
    'el inicio de estos datos est en Ini + 25
    Seek #1, Ini + 25
    Get #1, , Pos
    'Una vez situados en el inicio de los datos, lo 1 que nos encontramos
    'son 2 by con el n de apoyos
    Get #1, Ini + Pos, Napo
    'Dimensionamos las matrices de nombres de apoyos y de nudos de apoyos
    ReDim Nombre(Napo)
    ReDim Nudo(Napo)
    For I = 1 To Napo
	'Lo primero que hay es el n del nudo
	Get #1, , Nudo(I)
	'La longitud del nombre es
	Get #1, , Pos
	Nombre(I) = Space$(Pos)
	Get #1, , Nombre(I)
    Next I
    
    'Dibujaremos los apoyos que haya en la barra seleccionada, si estn todas
    'las barras seleccionadas, este IF no se ejecuta y dibujamos todos
    Pos = General!ListaBarras.ListIndex
    If Pos <> 0 Then
	'Tomamos el n de los nudos de la barra a dibujar, que son los que
	'aparecen en la lista de barras
	NudoIni = Val(Left$(General!ListaBarras.List(Pos), InStr(1, General!ListaBarras.List(Pos), "-") - 1))
	NudoFin = Val(Mid$(General!ListaBarras.List(Pos), InStr(1, General!ListaBarras.List(Pos), "-") + 1))
	'Vemos si alguno de ellos tiene asignado un apoyo, en cuyo caso
	'guardamos temporalmente en un string el n de nudo y el nombre de la
	'carga. Como mximo puede haber dos apoyos en una barra
	For I = 1 To Napo
	    If Nudo(I) = NudoIni Or Nudo(I) = NudoFin Then
		If CadVar1 = "" Then
		    CadVar1 = Nudo(I) & " " & Nombre(I)
		Else
		    CadVar2 = Nudo(I) & " " & Nombre(I)
		End If
		NNud = NNud + 1
	    End If
	Next I
	If NNud = 0 Then
	    'Si la barra no tiene nign apoyo, terminamos
	    Close #1
	    Exit Sub
	Else
	    'La barra puede tener 1 o dos apoyos
	    ReDim Nudo(NNud): ReDim Nombre(NNud)
	    Nudo(1) = Val(Left(CadVar1, InStr(1, CadVar1, " ") - 1))
	    Nombre(1) = Mid$(CadVar1, InStr(1, CadVar1, " ") + 1)
	    If NNud = 2 Then
		Nudo(2) = Val(Left(CadVar2, InStr(1, CadVar2, " ") - 1))
		Nombre(2) = Mid$(CadVar2, InStr(1, CadVar2, " ") + 1)
	    End If
	End If
	Napo = NNud
    End If
    
    'Una vez que tenemos los nudos y los nombres de los apoyos, slo
    'necesitamos las coordenadas de los nudos para colocarlos
    For I = 1 To Napo
	'Buscamos las coordenadas (singles) del nudo, ocupan 4 by cada una.
	'Las abscisas empiezan en el by 41
	Seek #1, 41 + (Nudo(I) - 1) * 4
	Get #1, , X
	'El inicio de las ordenadas se encuentra guardado en el 3 by
	Get #1, 3, Pos
	Seek #1, Pos + (Nudo(I) - 1) * 4
	Get #1, , Y
	'Cargamos el apoyo si es la 1 vez que lo dibujamos
	If Val(General!Apoyo(0).Tag) < Napo Then
	    General!Apoyo(0).Tag = Str$(Val(General!Apoyo(0).Tag) + 1)
	    Load General!Apoyo(Val(General!Apoyo(0).Tag))
	End If
	'Obtenemos la figura correspondiente y la colocamos
	General!Apoyo(I).Tag = Nombre(I)
	Select Case Nombre(I)
	    Case "Ca"
		If Papel.BackColor = RGB(255, 255, 255) Then
		    'Si Papel no est seleccionado, ponemos el apoyo normal
		    General!Apoyo(I).Picture = General!Ca.Picture
		ElseIf Donde = "Impresora" Then
		    General!Apoyo(0).Picture = General!Ca.Picture
		Else
		    'Si Papel est seleccionado, ponemos el apoyo inverso
		    General!Apoyo(I).Picture = General!Cas.Picture
		End If
	    Case "CaD"
		If Papel.BackColor = RGB(255, 255, 255) Then
		    General!Apoyo(I).Picture = General!CaD.Picture
		ElseIf Donde = "Impresora" Then
		    General!Apoyo(0).Picture = General!CaD.Picture
		Else
		    General!Apoyo(I).Picture = General!CaDs.Picture
		End If
	    Case "CaI"
		If Papel.BackColor = RGB(255, 255, 255) Then
		    General!Apoyo(I).Picture = General!CaI.Picture
		ElseIf Donde = "Impresora" Then
		    General!Apoyo(0).Picture = General!CaI.Picture
		Else
		    General!Apoyo(I).Picture = General!CaIs.Picture
		End If
	    Case "Em"
		If Papel.BackColor = RGB(255, 255, 255) Then
		    General!Apoyo(I).Picture = General!Em.Picture
		ElseIf Donde = "Impresora" Then
		    General!Apoyo(0).Picture = General!Em.Picture
		Else
		    General!Apoyo(I).Picture = General!Ems.Picture
		End If
	    Case "EmD"
		If Papel.BackColor = RGB(255, 255, 255) Then
		    General!Apoyo(I).Picture = General!EmD.Picture
		ElseIf Donde = "Impresora" Then
		    General!Apoyo(0).Picture = General!EmD.Picture
		Else
		    General!Apoyo(I).Picture = General!EmDs.Picture
		End If
	    Case "EmI"
		If Papel.BackColor = RGB(255, 255, 255) Then
		    General!Apoyo(I).Picture = General!EmI.Picture
		ElseIf Donde = "Impresora" Then
		    General!Apoyo(0).Picture = General!EmI.Picture
		Else
		    General!Apoyo(I).Picture = General!EmIs.Picture
		End If
	    Case "Ro"
		If Papel.BackColor = RGB(255, 255, 255) Then
		    General!Apoyo(I).Picture = General!Ro.Picture
		ElseIf Donde = "Impresora" Then
		    General!Apoyo(0).Picture = General!Ro.Picture
		Else
		    General!Apoyo(I).Picture = General!Ros.Picture
		End If
	    Case "RoD"
		If Papel.BackColor = RGB(255, 255, 255) Then
		    General!Apoyo(I).Picture = General!RoD.Picture
		ElseIf Donde = "Impresora" Then
		    General!Apoyo(0).Picture = General!RoD.Picture
		Else
		    General!Apoyo(I).Picture = General!RoDs.Picture
		End If
	    Case "RoI"
		If Papel.BackColor = RGB(255, 255, 255) Then
		    General!Apoyo(I).Picture = General!RoI.Picture
		ElseIf Donde = "Impresora" Then
		    General!Apoyo(0).Picture = General!RoI.Picture
		Else
		    General!Apoyo(I).Picture = General!RoIs.Picture
		End If
	End Select
	'Calculamos el ancho y el alto del n del nudo
	If General!BotonVerNum.Tag = "SI" Then
	    If Donde = "Papel" Then
		Ancho = Papel.TextWidth(LTrim(Str$(Nudo(I))))
		Alto = Papel.TextHeight(LTrim(Str$(Nudo(I))))
	    Else
		Ancho = Printer.TextWidth(LTrim(Str$(Nudo(I))))
		Alto = Printer.TextHeight(LTrim(Str$(Nudo(I))))
	    End If
	Else
	    If Donde = "Papel" Then
		Ancho = Papel.TextWidth(".") * .15
		Alto = Papel.TextHeight(".") * .15
	    Else
		Ancho = Printer.TextWidth(".") * .15
		Alto = Printer.TextHeight(".") * .15
	    End If
	End If
	
	'Calculamos las coordenadas donde ir la esquina superior
	'izquierda del apoyo con este Sub del mdulo DIAGRAMA.BAS
	PonDibujoApoyo X, Y, Ancho, Alto, General!Apoyo(I)
	If Donde = "Papel" Then
	    'Colocamos el apoyo en las coordenadas halladas
	    General!Apoyo(I).Move X, Y
	    'Lo hacemos visible
	    General!Apoyo(I).Visible = True
	Else
	    General!ApoyoImprimir.Picture = General!Apoyo(I).Picture
	    ImprimeImagen CInt(X), CInt(Y)
	End If
    Next I

    Close #1

End Sub

Sub DibujaCargas (Donde As String)
    'Dibuja las cargas de la estructura en el control Papel
    Dim Escala As Single, Maximo As Single, Color As Long, Azul As Long

    Azul = RGB(0, 0, 255)

    'Calculamos las diferencias mximas de las coordenadas de las cargas para
    'calcular su escala de trazado
    Maximo = CalcularMaxCargas()
    
    'Si Maximo es cero puede deberse a que todas las cargas sean flectores
    'o a que no haya cargas
    If Donde = "Papel" Then
	If Maximo = 0 Then Maximo = Abs(General!GrafCargas.ScaleHeight) * .3
	'La escala para el trazado de las cargas viene en funcin de la mxima
	'carga, ser el 23% del alto del control GrafCargas entre la mx carga
	Escala = Abs(General!GrafCargas.ScaleHeight) * .23 / Maximo
	'Las cargas se dibujan en azul salvo las puntuales
	Color = General!GrafCargas.ForeColor
	General!GrafCargas.ForeColor = Azul

	DibujaCargasB General!GrafCargas, Escala, Donde
    
	DibujaCargasN General!GrafCargas, Escala, Donde
    
	General!GrafCargas.ForeColor = Color
    Else
	If Maximo = 0 Then Maximo = Abs(Printer.ScaleHeight) * .3
	Escala = Abs(Printer.ScaleHeight) * .23 / Maximo
	Color = Printer.ForeColor
	Printer.ForeColor = Azul
	DibujaCargasB General!GrafCargas, Escala, Donde
	DibujaCargasN General!GrafCargas, Escala, Donde
	Printer.ForeColor = Color
    End If
    

End Sub

Sub DibujaCargasB (Papel As PictureBox, Escala As Single, Donde As String)
    'Dibuja las cargas de las barras

    Dim Nbar As Integer, Puntos() As Single, Color As Long
    Dim Barra As Estructura, Ini As Integer, CadN As String, Rojo As Long
    Dim I As Integer, Pos As Integer, CadVar As String, Nombre As String
    Dim Acumula As Integer, BarraIni As Integer, BarraFin As Integer
    
    Rojo = RGB(255, 0, 0)
    
    'Los componentes de Puntos sern las coordenadas de los 4 puntos que
    'definen a una carga repartida:
    '
    '        Xq1,Yq1 ----------------Xq2,Yq2
    '           |                       |
    '           |                       |
    '           |                       |
    '        Xp1,Yp1                 Xp2,Yp2
    'siendo el orden p1,q1,p2,q2. Si la carga es puntual slo aparecern
    'P1 y P2 y si es un flector slo p1. En Puntos(0) vendr el signo del
    'flector (+1, -1)
    
    Open Mid$(General.Caption, 12) For Binary As #1
    Get #1, 1, Ini  'Inicio de los datos de dibujo
    Ini = Ini - 1
    Get #1, 17, Nbar

    'Tomamos los datos dependiendo de la barra a dibujar
    If General!ListaBarras.ListIndex = 0 Then
	'Si tenemos seleccionado el 1 elemento (todas)
	BarraIni = 1
	BarraFin = Nbar
    Else
	BarraIni = General!ListaBarras.ListIndex
	BarraFin = BarraIni
	'Localizamos el inicio de la carga de la barra seleccionada
	For I = 1 To BarraFin - 1
	    'De la posicin 17 obtenemos el inicio de las cargas en barras
	    Pos = Ini + 17
	    Seek #1, Pos
	    Get #1, , Pos
	    'Vamos hasta all, Acumula= long. de todas las cargas anteriores
	    Seek #1, Ini + Pos + Acumula
	    'Obtenemos la longitud de la carga
	    Get #1, , Pos
	    'La guardamos en Acumula para conocer el inicio de la prxima, en
	    'Pos est la longitud de la carga y el 2 son los by que ocupan la
	    'longitud de la cadena de la carga uqe hay al ppo. de cada carga
	    Acumula = Acumula + Pos + 2
	Next I
    End If
    
    For I = BarraIni To BarraFin
	'De la posicin 17 obtenemos el inicio de las cargas en barras
	Pos = Ini + 17
	Seek #1, Pos
	Get #1, , Pos
	'Vamos hasta all, Acumula= long. de todas las cargas anteriores
	Seek #1, Ini + Pos + Acumula
	'Obtenemos la longitud de la carga
	Get #1, , Pos
	'La guardamos en Acumula para conocer el inicio de la prxima, en Pos
	'est la longitud de la carga y el 2 son los by de la longitud de
	'la cadena de la carga
	Acumula = Acumula + Pos + 2
	'Obtenemos la carga
	CadVar = Space$(Pos)
	Get #1, , CadVar
	'Si la carga no existe, probamos con la sig. barra
	If CadVar <> "" Then
	    'Tomamos la barra, empiezan en la posicin 27 relativa a Ini y
	    'cada una ocupa 28 by
	    Pos = Ini + 27 + (I - 1) * 28
	    Get #1, Pos, Barra
	    'Hacemos un bucle para obtener los ptos. de cada una de las cargas
	    Do
		ReDim Puntos(8)
		'Hallamos el final de la carga actual
		Pos = InStr(1, CadVar, "/")
		'Obtenemos la carga actual y se la quitamos a la cadena general
		CadN = Left$(CadVar, Pos - 1)
		CadVar = Mid$(CadVar, Pos + 1)
		Nombre = Left$(CadN, 1)
		'Obtenemos los puntos
		DamePuntos Puntos(), Barra, CadN, Escala
		'Dibujamos la carga dependiendo de si es un flector o no
		If Puntos(0) <> 0 Then
		    If Puntos(0) > 0 Then
			If Donde = "Papel" Then
			    Papel.Circle (Puntos(1), Puntos(2)), Puntos(0), , PI / 3, 5 * PI / 3
			    If General!VerTrazado.Checked Then DoEvents
			Else
			    Printer.DrawWidth = 2
			    Printer.Circle (Puntos(1), Puntos(2)), Puntos(0), , PI / 3, 5 * PI / 3
			    Printer.DrawWidth = 1
			End If
		    Else
			Puntos(0) = Abs(Puntos(0))
			If Donde = "Papel" Then
			    Papel.Circle (Puntos(1), Puntos(2)), Puntos(0), , 4 * PI / 3, 2 * PI / 3
			    If General!VerTrazado.Checked Then DoEvents
			Else
			    Printer.DrawWidth = 2
			    Printer.Circle (Puntos(1), Puntos(2)), Puntos(0), , 4 * PI / 3, 2 * PI / 3
			    Printer.DrawWidth = 1
			End If
		    End If
		Else
		    If Nombre = "P" Then
			Color = Rojo
			If Donde = "Papel" Then
			    Papel.DrawWidth = 2
			Else
			    Printer.DrawWidth = 4
			End If
		    Else
			If Donde = "Papel" Then
			    Color = Papel.ForeColor
			Else
			    Printer.DrawWidth = 2
			    Color = Printer.ForeColor
			End If
		    End If
		    If Donde = "Papel" Then
			Papel.Line (Puntos(1), Puntos(2))-(Puntos(3), Puntos(4)), Color
			Papel.DrawWidth = 1
			'Si la carga es repartida, dibujamos lo dems
			If Nombre = "R" Then
			    Papel.Line -(Puntos(7), Puntos(8))
			    Papel.Line -(Puntos(5), Puntos(6))
			End If
		    Else
			Printer.Line (Puntos(1), Puntos(2))-(Puntos(3), Puntos(4)), Color
			If Nombre = "R" Then
			    Printer.Line -(Puntos(7), Puntos(8))
			    Printer.Line -(Puntos(5), Puntos(6))
			    If General!VerTrazado.Checked Then DoEvents
			End If
			Printer.DrawWidth = 1
		    End If
		End If
	    Loop Until Len(CadVar) = 0
	End If
    Next I

    Close #1


End Sub

Sub DibujaCargasN (Papel As PictureBox, Escala As Single, Donde As String)
    Dim NNud As Integer, Puntos() As Single
    Dim Barra As Estructura, Ini As Integer, CadN As String
    Dim I As Integer, Pos As Integer, CadVar As String, Radio As Single
    Dim Rojo As Long, Color As Long
    Dim NudoIni As Integer, NudoFin As Integer, Nudo As Integer
    
    Rojo = RGB(255, 0, 0)

    'El radio de los flectores ser constante e igual al 5% de la menor
    'escala de pantalla
    If Abs(Papel.ScaleHeight) < Abs(Papel.ScaleWidth) Then
	If Donde = "Impresora" Then
	    Radio = Abs(Printer.ScaleHeight) * .05
	Else
	    Radio = Abs(Papel.ScaleHeight) * .05
	End If
    Else
	If Donde = "Impresora" Then
	    Radio = Abs(Printer.ScaleWidth) * .05
	Else
	    Radio = Abs(Papel.ScaleWidth) * .05
	End If
    End If
    
    'Los componentes de Puntos sern las coordenadas del punto Q1 que
    'define a una carga puntual, P1 es el propio nudo
    '
    '        Xq1,Yq1
    '           |
    '           |
    '           |
    '        Xp1,Yp1
    'Si es un flector no lo tendremos en cuenta, ya que su radio es fijo

    Open Mid$(General.Caption, 12) For Binary As #1
    Get #1, 1, Ini  'Inicio de los datos de dibujo
    Ini = Ini - 1
    Get #1, 15, NNud
    
    ReDim X(NNud)
    ReDim Y(NNud)
    
    'Las abscisas empiezan en la posicin 41
    Seek #1, 41
    For I = 1 To NNud
	Get #1, , X(I)
    Next I
    'El inicio de las ordenadas se guarda en la posicin 3 y 4
    Get #1, 3, Pos
    Seek #1, Pos
    For I = 1 To NNud
	Get #1, , Y(I)
    Next I
    
    'Tomamos los datos dependiendo de la barra a dibujar
    Pos = General!ListaBarras.ListIndex
    If Pos > 0 Then
	'Si hemos seleccionado ver una sola barra, tomamos el n de los nudos
	'que son los que aparecen en la lista de barras
	NudoIni = Val(Left$(General!ListaBarras.List(Pos), InStr(1, General!ListaBarras.List(Pos), "-") - 1))
	NudoFin = Val(Mid$(General!ListaBarras.List(Pos), InStr(1, General!ListaBarras.List(Pos), "-") + 1))
    End If
    
    'La posicin del inicio de las cargas en los nudos, se guarda en Ini + 21
    Pos = Ini + 21
    Seek #1, Pos
    Get #1, , Pos
    'Colocamos el puntero en el comienzo de las cargas de nudos
    Pos = Ini + Pos
    Seek #1, Pos
    For I = 1 To NNud
	'Obtenemos el n del nudo
	Get #1, , Nudo
	'Obtenemos la longitud de la carga
	Get #1, , Pos
	'Obtenemos la carga
	CadVar = Space$(Pos)
	Get #1, , CadVar
	If General!ListaBarras.ListIndex > 0 Then
	    'Si tenemos elegida una barra y este nudo no le pertenece,
	    'vaciamos la cadena de carga para que no se dibuje y pasar al
	    'siguiente nudo
	    If Nudo <> NudoIni And Nudo <> NudoFin Then
		CadVar = ""
	    End If
	End If
	'Si la carga no existe, probamos con el sig. nudo
	If CadVar <> "" Then
	    'La funcin que obtiene los ptos de trazado precisa como argumento
	    'un Type Barra, as que ponemos las coordenadas del nudo en l.
	    'Las coordenadas del pto. J se dan para que cuando trabajemos con
	    'un flector, DamePuntos devuelva siempre un valor <> 0 en
	    'Puntos (0), de esta forma sabemos que no hay que dibujar una
	    'puntual
	    Barra.Xi = X(Nudo)
	    Barra.Yi = Y(Nudo)
	    Barra.Xj = Barra.Xi + 10
	    Barra.Yj = Barra.Yi + 10
	    'Hacemos un bucle para obtener los ptos. de cada una de las cargas
	    Do
		ReDim Puntos(8)
		'Hallamos el final de la carga actual
		Pos = InStr(1, CadVar, "/")
		'Obtenemos la carga actual y se la quitamos a la cadena general
		CadN = Left$(CadVar, Pos - 1)
		CadVar = Mid$(CadVar, Pos + 1)
		DamePuntos Puntos(), Barra, CadN, Escala
		'Miramos si es un flector
		If Puntos(0) <> 0 Then
		    If Puntos(0) > 0 Then
			If Donde = "Papel" Then
			    Papel.Circle (Puntos(1), Puntos(2)), Radio, , PI / 3, 5 * PI / 3
			Else
			    Printer.DrawWidth = 2
			    Printer.Circle (Puntos(1), Puntos(2)), Radio, , PI / 3, 5 * PI / 3
			    Printer.DrawWidth = 1
			End If
		    Else
			Puntos(0) = Abs(Puntos(0))
			If Donde = "Papel" Then
			    Papel.Circle (Puntos(1), Puntos(2)), Radio, , 4 * PI / 3, 2 * PI / 3
			Else
			    Printer.DrawWidth = 2
			    Printer.Circle (Puntos(1), Puntos(2)), Radio, , 4 * PI / 3, 2 * PI / 3
			    Printer.DrawWidth = 1
			End If
		    End If
		Else
		    If Donde = "Papel" Then
			Papel.DrawWidth = 2
			Papel.Line (Puntos(1), Puntos(2))-(Puntos(3), Puntos(4)), Rojo
			Papel.DrawWidth = 1
		    Else
			Printer.DrawWidth = 4
			Printer.Line (Puntos(1), Puntos(2))-(Puntos(3), Puntos(4)), Rojo
			Printer.DrawWidth = 1
		    End If
		End If
	    Loop Until Len(CadVar) = 0
	End If
    Next I
    
    Close #1

End Sub

Sub DibujaEstructura (Papel As PictureBox, Donde As String)
    'Dibuja la estructura el control de figuras dado como parmetro
    
    Dim Xii As Single, Yii As Single, Xsd As Single, Ysd As Single
    Dim Alto As Single, Ancho As Single, Nombre As String
    Dim XMaxE As Single, XMinE As Single, YMaxE As Single, YMinE As Single
    Dim AltoReal As Single, AnchoReal As Single, Pos As Integer
    Dim AltoPapel As Single, AnchoPapel As Single, Nbar As Integer
    Dim Barra As Estructura, Ini As Integer, I As Integer
    Dim BarraIni As Integer, BarraFin As Integer, Ni As Integer, Nj As Integer
    Dim MarcoH As Single, MarcoV As Single, L As Single
    
    Nombre = Papel.Tag
    
    'Dibujamos la barra seleccionada en la lista de barras
    If General!ListaBarras.ListIndex = -1 Then
	'Si no hay ninguna seleccionada (ListIndex=-1), seleccionamos todas
	General!ListaBarras.ListIndex = 0
    End If
    Nbar = General!ListaBarras.ListIndex

    'Abrimos el fichero y obtenemos las coord. extremas de la estructura
    Open Mid$(General.Caption, 12) For Binary As #1
    'Inicio de los datos de dibujo
    Get #1, 1, Ini
    Ini = Ini - 1

    'Tomamos los datos dependiendo de la barra a dibujar
    If Nbar = 0 Then
	'Si tenemos seleccionado el 1 elemento (todas)
	Get #1, 25, XMaxE
	Get #1, 29, XMinE
	Get #1, 33, YMaxE
	Get #1, 37, YMinE
	'N de barras
	BarraIni = 1
	Get #1, 17, BarraFin
    Else
	'El n de los nudos de la barra es:
	Ni = Val(Left$(General!ListaBarras.List(Nbar), InStr(1, General!ListaBarras.List(Nbar), "-") - 1))
	Nj = Val(Mid$(General!ListaBarras.List(Nbar), InStr(1, General!ListaBarras.List(Nbar), "-") + 1))
	'Tomamos el n de barras de la estructura
	Get #1, 17, Nbar
	'Buscamos la barra seleccionada en la lista de barras
	For I = 1 To Nbar
	    'Tomamos la barra, empiezan en la posicin 27 relativa a Ini y
	    'cada una ocupa 28 by
	    Pos = Ini + 27 + (I - 1) * 28
	    Get #1, Pos, Barra
	    'Si los nudos coinciden con los de la lista de barras esa es la
	    'barra
	    If Barra.NudoI = Ni And Barra.NudoJ = Nj Then
		Exit For
	    End If
	Next I
	XMaxE = Barra.Xj
	XMinE = Barra.Xi
	YMaxE = Barra.Yj
	YMinE = Barra.Yi
	'La mayor X es siempre Xj, no ocurre lo mismo con las Y
	If YMinE > YMaxE Then
	    YMaxE = Barra.Yi
	    YMinE = Barra.Yj
	End If
	BarraIni = I
	BarraFin = I
	'Obtenemos las variables sena y cosa que son el seno y coseno de la
	'barra seleccionada, respecto a los ejes generales
	L = Sqr((Barra.Xj - Barra.Xi) ^ 2 + (Barra.Yj - Barra.Yi) ^ 2)
	sena = (Barra.Yj - Barra.Yi) / L
	cosa = (Barra.Xj - Barra.Xi) / L
    End If

    'Calculamos los tamaos de la estructura y de la pantalla donde dibujarla
    'Tamao de la estructura a representar:
    AltoReal = Abs(YMaxE - YMinE)
    AnchoReal = Abs(XMaxE - XMinE)
    'Ponemos las coordenadas por defecto de la caja de figuras
    If Donde = "Papel" Then
	Papel.Scale
	'Tamao en twips de la caja de figuras (sin contar el marco):
	AltoPapel = Papel.ScaleHeight
	AnchoPapel = Papel.ScaleWidth
    Else
	Printer.Scale
	'Tamao en twips de la impresora
	AltoPapel = Printer.ScaleHeight
	AnchoPapel = Printer.ScaleWidth
    End If
    'Calculamos la escala del dibujo dependiendo de si la estructura es una
    'viga (no tiene alto), un pilar (no tiene ancho) o tiene alto y ancho
    If AltoReal < AnchoReal * .03 Then
	'Si el alto es menor del 3% del ancho, es una viga
	'El ancho y alto que debe representarse en la caja de figuras es
	Ancho = AnchoReal * 2
	Alto = AnchoReal * (AltoPapel / AnchoPapel)
	'Las coordenadas del punto inferior izquierdo de la caja de figuras
	'han de ser
	Xii = XMinE - Ancho * .25
	Yii = YMinE - Alto * .5
    ElseIf AnchoReal < AltoReal * .03 Then
	'Si el ancho es menor del 3% del alto, es un pilar
	Alto = AltoReal * 2
	Ancho = Alto * (AnchoPapel / AltoPapel)
	Xii = XMinE - Ancho * .5
	Yii = YMinE - AltoReal * .35
    Else
	'Si tiene alto y ancho considerable
	If Donde = "Papel" Then
	    Alto = AltoReal * 2
	    Ancho = Alto * (AnchoPapel / AltoPapel)
	    'El ancho a representar ser, almenos, el 150% del real
	    If AnchoReal * 1.5 >= Ancho Then Ancho = AnchoReal * 1.5
	    Xii = XMinE - (Ancho - AnchoReal) * .5
	    Yii = YMinE - Alto * .25
	Else
	    'Si vamos a imprimir en la impresora, hemos de distinguir entre
	    'impresin vertical o apaisada
	    If AltoPapel >= AnchoPapel Then
		Alto = AltoReal * 2
		Ancho = Alto * (AnchoPapel / AltoPapel)
		If AnchoReal * 2 >= Ancho Then
		    Ancho = AnchoReal * 2
		    Alto = Ancho * (AltoPapel / AnchoPapel)
		End If
	    Else
		Ancho = AnchoReal * 2
		Alto = Ancho * (AltoPapel / AnchoPapel)
		If AltoReal * 2 >= Alto Then
		    Alto = AltoReal * 2
		    Ancho = Alto * (AnchoPapel / AltoPapel)
		End If
	    End If
	    Xii = XMinE - (Ancho - AnchoReal) * .5
	    Yii = YMinE - (Alto - AltoReal) * .5
	End If
    End If
    If Donde = "Papel" Then
	'El marco de Papel no cuenta para el trazado, hay que descontarlo:
	'son 15 twips a cada lado.
	MarcoH = 30 * (Ancho / AnchoPapel)
	MarcoV = 30 * (Alto / AltoPapel)
	Xii = Xii - MarcoH / 2
	Yii = Yii - MarcoV / 2
	'Las coordenadas del punto superior derecho de la caja de figuras:
	Xsd = Xii + Ancho + MarcoH
	Ysd = Yii + Alto + MarcoV
    Else
	'Hay que descontar los mrgenes de la impresora
	MarcoH = (Printer.Width - Printer.ScaleWidth) * Ancho / Printer.ScaleWidth
	MarcoV = (Printer.Height - Printer.ScaleHeight) * Alto / Printer.ScaleHeight
	Xii = Xii - MarcoH / 2
	Yii = Yii - 2 * MarcoV / 3
	'Las coordenadas del punto superior derecho de la caja de figuras:
	Xsd = Xii + Ancho + MarcoH
	Ysd = Yii + Alto + MarcoV
    End If
    'Establecemos la escala del control, el nombre y el criterio de signos
    If Donde = "Papel" Then
	Papel.ScaleMode = 4: Papel.Scale
	Papel.CurrentX = 0: Papel.CurrentY = 0
	Papel.Print Nombre
	Papel.CurrentX = 0: Papel.CurrentY = Papel.TextHeight("1")
	Papel.Print General!ListaBarras.List(General!ListaBarras.ListIndex)
	Papel.CurrentY = Papel.TextHeight("1") * 2
	If Nombre = "Normales" Then
	    General!SignoN.Left = 0: General!SignoN.Top = Papel.CurrentY: General!SignoN.Visible = True
	ElseIf Nombre = "Cortantes" Then
	    General!SignoC.Left = 0: General!SignoC.Top = Papel.CurrentY: General!SignoC.Visible = True
	ElseIf Nombre = "Flectores" Then
	    General!SignoM.Left = 0: General!SignoM.Top = Papel.CurrentY: General!SignoM.Visible = True
	ElseIf Nombre = "Giros" Then
	    General!SignoG.Left = 0: General!SignoG.Top = Papel.CurrentY: General!SignoG.Visible = True
	ElseIf Nombre = "Deformada" Then
	    General!SignoD.Left = 0: General!SignoD.Top = Papel.CurrentY: General!SignoD.Visible = True
	End If
	Papel.Scale (Xii, Ysd)-(Xsd, Yii)
    Else
	Printer.ScaleMode = 4
	Nombre = General.Caption + " ; " + Nombre + " de la barra: " + General!ListaBarras.List(General!ListaBarras.ListIndex)
	Printer.CurrentX = Printer.ScaleWidth / 2 - Printer.TextWidth(Nombre) / 2
	Printer.CurrentY = 2
	Printer.Scale (Xii, Ysd)-(Xsd, Yii)
	Printer.Print Nombre
    End If
    'Dibujamos las barras seleccionadas
    
    For I = BarraIni To BarraFin
	'Tomamos la barra, empiezan en la posicin 27 relativa a Ini y cada
	'una ocupa 28 by
	Pos = Ini + 27 + (I - 1) * 28
	Get #1, Pos, Barra
	'Dibujamos la lnea
	If Donde = "Papel" Then
	    Papel.Line (Barra.Xi, Barra.Yi)-(Barra.Xj, Barra.Yj)
	Else
	    Printer.Line (Barra.Xi, Barra.Yi)-(Barra.Xj, Barra.Yj)
	End If
    Next I
    
    Close #1

End Sub

Sub DibujaNumerosNudos (Papel As PictureBox, Donde As String)
    'Coloca la numeracin de los nudos en el control Papel
    Dim Barra As Estructura, Ini As Integer, I As Integer, NumNudo As String
    Dim Nbar As Integer, X As Single, Y As Single, Pos As Integer
    Dim SalvaColor As Long, Rojo As Long, Blanco As Long, BarraIni As Integer
    Dim BarraFin As Integer, Ni As Integer, Nj As Integer

    Rojo = RGB(255, 0, 0)
    Blanco = RGB(255, 255, 255)

    'Elegimos la fuente para el texto
    If Donde = "Papel" Then
	Papel.FontName = "Small Fonts"
	Papel.FontSize = 6
    Else
	Printer.FontBold = True
    End If
    
    'Abrimos el fichero y obtenemos las barras
    Open Mid$(General.Caption, 12) For Binary As #1
    'Inicio de los datos de dibujo
    Get #1, 1, Ini
    Ini = Ini - 1
    Get #1, 17, Nbar
    
    'Tomamos los datos dependiendo de la barra a dibujar
    Pos = General!ListaBarras.ListIndex
    If Pos = 0 Then
	'Si tenemos seleccionado el 1 elemento (todas)
	BarraIni = 1
	BarraFin = Nbar
    Else
	'El n de los nudos de la barra es:
	Ni = Val(Left$(General!ListaBarras.List(Pos), InStr(1, General!ListaBarras.List(Pos), "-") - 1))
	Nj = Val(Mid$(General!ListaBarras.List(Pos), InStr(1, General!ListaBarras.List(Pos), "-") + 1))
	'Buscamos la barra seleccionada en la lista de barras
	For I = 1 To Nbar
	    'Tomamos la barra, empiezan en la posicin 27 relativa a Ini y
	    'cada una ocupa 28 by
	    Pos = Ini + 27 + (I - 1) * 28
	    Get #1, Pos, Barra
	    'Si los nudos coinciden con los de la lista de barras esa es la
	    'barra
	    If Barra.NudoI = Ni And Barra.NudoJ = Nj Then
		Exit For
	    End If
	Next I
	BarraIni = I
	BarraFin = BarraIni
    End If
    
    For I = BarraIni To BarraFin
	'Tomamos la barra, empiezan en la posicin 27 relativa a Ini y cada
	'una ocupa 28 by
	Pos = Ini + 27 + (I - 1) * 28
	Get #1, Pos, Barra
	NumNudo = LTrim(Str$(Barra.NudoI))
	If Donde = "Papel" Then
	    SalvaColor = Papel.ForeColor
	    Papel.ForeColor = Rojo
	    'Borramos el rea necesaria para que se vea el n, trazamos una
	    'caja del color del fondo y del tamao del n del nudo
	    Papel.CurrentX = Barra.Xi - Papel.TextWidth(NumNudo) / 2
	    Papel.CurrentY = Barra.Yi + Papel.TextHeight(NumNudo) / 2
	    X = Papel.CurrentX + Papel.TextWidth(NumNudo)
	    Y = Papel.CurrentY - Papel.TextHeight(NumNudo)
	    Papel.Line -(X, Y), Papel.BackColor, BF
	    Papel.CurrentX = Barra.Xi - Papel.TextWidth(NumNudo) / 2
	    Papel.CurrentY = Barra.Yi + Papel.TextHeight(NumNudo) / 2
	    X = Papel.CurrentX + Papel.TextWidth(NumNudo)
	    Y = Papel.CurrentY - Papel.TextHeight(NumNudo)
	    Papel.Line -(X, Y), Papel.BackColor, BF
	    'Colocamos el n del nudo i
	    Papel.CurrentX = Barra.Xi - Papel.TextWidth(NumNudo) / 2
	    Papel.CurrentY = Barra.Yi + Papel.TextHeight(NumNudo) / 2
	    'Los dibujamos de rojo
	    Papel.Print NumNudo
	    'Colocamos el n del nudo j
	    NumNudo = LTrim(Str$(Barra.NudoJ))
	    Papel.CurrentX = Barra.Xj - Papel.TextWidth(NumNudo) / 2
	    Papel.CurrentY = Barra.Yj + Papel.TextHeight(NumNudo) / 2
	    X = Papel.CurrentX + Papel.TextWidth(NumNudo)
	    Y = Papel.CurrentY - Papel.TextHeight(NumNudo)
	    Papel.Line -(X, Y), Papel.BackColor, BF
	    Papel.CurrentX = Barra.Xj - Papel.TextWidth(NumNudo) / 2
	    Papel.CurrentY = Barra.Yj + Papel.TextHeight(NumNudo) / 2
	    Papel.Print NumNudo
	    'Colocamos el color original
	    Papel.ForeColor = SalvaColor
	Else
	    SalvaColor = Printer.ForeColor
	    Printer.ForeColor = Rojo
	    'Colocamos el n del nudo i
	    Printer.CurrentX = Barra.Xi - Printer.TextWidth(NumNudo) / 2
	    Printer.CurrentY = Barra.Yi + Printer.TextHeight(NumNudo) / 2
	    'Los dibujamos de rojo
	    Printer.Print NumNudo
	    'Colocamos el n del nudo j
	    NumNudo = LTrim(Str$(Barra.NudoJ))
	    Printer.CurrentX = Barra.Xj - Printer.TextWidth(NumNudo) / 2
	    Printer.CurrentY = Barra.Yj + Printer.TextHeight(NumNudo) / 2
	    Printer.Print NumNudo
	End If
	
    Next I

    Close #1

End Sub

Sub DivideFormulario ()
    Dim Alto As Integer, Ancho As Integer

    'Dividimos al formulario en dos columnas de tres filas
    Alto = (General.ScaleHeight - General!BarraH.Height - General!PiePag.Height) \ 3
    Ancho = General.ScaleWidth \ 2

    'En la fila 1, columna 1 ponemos el control de figuras con las cargas
    General!GrafCargas.Height = Alto
    General!GrafCargas.Width = Ancho
    General!GrafCargas.Top = General!BarraH.Height
    General!GrafCargas.Left = 0
    'En la fila 2, columna 1 ponemos el control de figuras de cortantes
    General!GrafCortantes.Height = Alto
    General!GrafCortantes.Width = Ancho
    General!GrafCortantes.Top = General!BarraH.Height + Alto
    General!GrafCortantes.Left = 0
    'En la fila 3, columna 1 ponemos el control de figuras de flectores
    General!GrafFlectores.Height = Alto
    General!GrafFlectores.Width = Ancho
    General!GrafFlectores.Top = General!BarraH.Height + 2 * (Alto)
    General!GrafFlectores.Left = 0
    'En la fila 1, columna 2 ponemos el control de figuras de normales
    General!GrafNormales.Height = Alto
    General!GrafNormales.Width = Ancho
    General!GrafNormales.Top = General!BarraH.Height
    General!GrafNormales.Left = Ancho
    'En la fila 2, columna 2 ponemos el control de figuras de ngulos
    General!GrafGiros.Height = Alto
    General!GrafGiros.Width = Ancho
    General!GrafGiros.Top = General!BarraH.Height + Alto
    General!GrafGiros.Left = Ancho
    'En la fila 3, columna 2 ponemos el control de figuras de deflexiones
    General!GrafDeflexiones.Height = Alto
    General!GrafDeflexiones.Width = Ancho
    General!GrafDeflexiones.Top = General!BarraH.Height + 2 * (Alto)
    General!GrafDeflexiones.Left = Ancho

End Sub

Sub EcuacionesDesplazamientos ()
    'Crea la ecuacin de desplazamientos en ejes generales de todas las barras
    'de la estructura.

    Dim CaD As String, iba As Integer, IncrementoL As Single, K As Single
    Dim Xi As Single, Xj As Single, Yi As Single, Yj As Single
    Dim ViejaL As Single, NuevaL As Single, NudoI As Integer, NudoJ As Integer
    Dim Var As Single, Ec As String, Nba As Integer, P As Integer
    Dim ElementoA As Single, ElementoN As Single, ElementoP As Single

    Nba = General!ListaBarras.ListCount - 1
    
    ReDim EcDefX(1 To Nba): ReDim EcDefY(1 To Nba)
    
    For iba = 1 To Nba
	CaD = "": Var = 0: Ec = ""
	NudoI = Val(Left$(General!ListaBarras.List(iba), InStr(1, General!ListaBarras.List(iba), "-") - 1))
	NudoJ = Val(Mid$(General!ListaBarras.List(iba), InStr(1, General!ListaBarras.List(iba), "-") + 1))
	'Para hallar los desplazamientos en el sentido X de los ejes generales
	'vemos 1 si el sistema nos ha dado desplazamientos en este sentido
	Var = Movimientos(NudoI, 1)
	If Var <> 0 Then
	    'En ese caso hay que introducirlos como una cte.
	    Var = Format(Var * Inercia(iba), "0.#####")
	    EcDefX(iba) = "0;0;" + LTrim(Str$(Var)) + ";"
	End If
	'Para hallar los desplazamientos en la direccin Y
	Var = Movimientos(NudoI, 2)
	If Var <> 0 Then
	    Var = Format(Var * Inercia(iba), "0.#####")
	    EcDefY(iba) = "0;0;" + LTrim(Str$(Var)) + ";"
	End If
	'Vemos ahora la contribucin que hacen los incrementos de longitud de
	'la barra a las ec. X e Y
	ViejaL = Sqr((X(NudoJ) - X(NudoI)) ^ 2 + (Y(NudoJ) - Y(NudoI)) ^ 2)
	sena = (Y(NudoJ) - Y(NudoI)) / ViejaL
	cosa = (X(NudoJ) - X(NudoI)) / ViejaL
	Xi = X(NudoI) + Movimientos(NudoI, 1)
	Xj = X(NudoJ) + Movimientos(NudoJ, 1)
	Yi = Y(NudoI) + Movimientos(NudoI, 2)
	Yj = Y(NudoJ) + Movimientos(NudoJ, 2)
	NuevaL = Sqr((Xj - Xi) ^ 2 + (Yj - Yi) ^ 2)
	IncrementoL = NuevaL - ViejaL
	K = IncrementoL / ViejaL
	'La proyeccin del incremento de longitud sobre el eje X ser
	If K * cosa <> 0 Then
	    Var = Format(K * cosa * Inercia(iba), "0.#####")
	    EcDefX(iba) = EcDefX(iba) + "0;1;" + LTrim(Str$(Var)) + ";"
	End If
	'Sobre el Y
	If K * sena <> 0 Then
	    Var = Format(K * sena * Inercia(iba), "0.#####")
	    EcDefY(iba) = EcDefY(iba) + "0;1;" + LTrim(Str$(Var)) + ";"
	End If
	'Integramos la ec de giros para obtener la de deflexiones. Previamente
	'proyectamos sobre los ejes generales
	If EcGir(iba) <> "" Then
	    Ec = EcGir(iba)
	    Do
		ElementoA = Val(Ec)
		P = InStr(1, Ec, ";")
		Ec = Mid$(Ec, P + 1)
		ElementoN = Val(Ec)
		P = InStr(1, Ec, ";")
		Ec = Mid$(Ec, P + 1)
		'Proyectamos
		ElementoP = Format(Val(Ec) * sena, "0.#####")
		P = InStr(1, Ec, ";")
		Ec = Mid$(Ec, P + 1)
		CaD = CaD + LTrim(Str$(ElementoA)) + ";" + LTrim(Str$(ElementoN)) + ";" + LTrim(Str$(ElementoP)) + ";"
	    Loop Until Ec = ""
	    Integra CaD, Ec
	End If
	'Colocamos la carga en su matriz
	EcDefX(iba) = EcDefX(iba) + Ec
	'Para el eje Y
	CaD = ""
	If EcGir(iba) <> "" Then
	    Ec = EcGir(iba)
	    Do
		ElementoA = Val(Ec)
		P = InStr(1, Ec, ";")
		Ec = Mid$(Ec, P + 1)
		ElementoN = Val(Ec)
		P = InStr(1, Ec, ";")
		Ec = Mid$(Ec, P + 1)
		'Proyectamos
		ElementoP = Format(-Val(Ec) * cosa, "0.#####")
		P = InStr(1, Ec, ";")
		Ec = Mid$(Ec, P + 1)
		CaD = CaD + LTrim(Str$(ElementoA)) + ";" + LTrim(Str$(ElementoN)) + ";" + LTrim(Str$(ElementoP)) + ";"
	    Loop Until Ec = ""
	    Integra CaD, Ec
	End If
	EcDefY(iba) = EcDefY(iba) + Ec
    Next iba

End Sub

Function FicheroA (Formulario As Form)
    Dim Fichero As String, Camino As String, Unidad As String
    Dim Pos As Integer, Msg As String
    
    Formulario!CMDialog1.CancelError = True
    On Error Resume Next

InicioA:

    'Filtros de ficheros y filtro por defecto
    Formulario!CMDialog1.Filter = "Ficheros de datos (*.ubu)|*.ubu|"
    Formulario!CMDialog1.FilterIndex = 1

    'Visualizamos la caja de dilogo abrir
    Formulario!CMDialog1.Action = 1

    'Si se puls cancelar
    If Err = 32755 Then
	Boton = 2
	FicheroA = ""
	Exit Function
    End If

    'Guardamos el nombre y el camino
    Fichero = Formulario!CMDialog1.Filetitle
    Camino = Formulario!CMDialog1.Filename
    Pos = InStr(1, Camino, Fichero)
    Camino = Left$(Camino, Pos - 2)
    Unidad = Left$(Camino, 2)

    'Cambiamos al nuevo path
    'Si la unidad del fichero es distinta a la actual
    If Unidad <> Left$(CurDir, 2) Then
	'Cambiamos a dicha unidad
	ChDrive Unidad
    End If
    'Si el path es distinto al actual, cambiamos al nuevo path
    If Camino <> CurDir Then
	ChDir Camino
    End If
    
    RutaActual = Camino

    'Comprobamos si existe el fichero
    If Not FileExists(Fichero) Then
	Msg = "El fichero no existe o est vaco"
	MsgBox Msg, 48, "Atencin!"
	GoTo InicioA
    End If
    
    'Devolvemos el nombre del fichero
    FicheroA = Fichero

End Function

Function FileExists (Path$) As Integer
    Dim X As Integer

    'Busca si existe el archivo especificado en el path
    X = FreeFile

    On Error Resume Next
    Open Path$ For Input As X
    If Err = 0 Then
	FileExists = True
    Else
	FileExists = False
    End If
    Close X

End Function

Sub Formatea (Num As String)
    Dim ValNum As Single

    ValNum = Val(Num)
    If UdsLong = "M" Then
	If ValNum >= .01 Then
	    ValNum = Format(ValNum, "#.##")
	Else
	    ValNum = 0
	End If
    Else
	If ValNum >= 1 Then
	    ValNum = Format(ValNum, "#")
	Else
	    ValNum = 0
	End If
    End If

    Num = LTrim(Str$(ValNum))

End Sub

Sub GeneralNuevo ()
    Dim I As Integer, GrisO As Long
    
    GrisO = &H808080

    'Activamos la lista de barras
    General!ListaBarras.Enabled = True
    General!Label3.ForeColor = RGB(0, 0, 0)
    
    'Borramos las matrices dinmicas
    Erase Barra: Erase MatrizLongitudes: Erase X: Erase Y
    Erase CargaB: Erase CargaN: Erase Normales: Erase Cortantes
    Erase Flectores: Erase Valores: Erase Movimientos
    Erase EcNor: Erase EcCor: Erase EcFle: Erase EcGir: Erase EcDef
    Erase EcDefX: Erase EcDefY: Erase Inercia

    'Hacemos visibles todos los controles
    General!GrafCargas.Visible = True
    General!GrafNormales.Visible = True
    General!GrafCortantes.Visible = True
    General!GrafFlectores.Visible = True
    General!GrafGiros.Visible = True
    General!GrafDeflexiones.Visible = True
    'Borramos todas las cajas de figuras y ponemos los colores iniciales
    General!GrafCargas.Picture = LoadPicture()
    General!GrafCargas.ForeColor = 0
    General!GrafCargas.BackColor = RGB(255, 255, 255)
    General!GrafGiros.Picture = LoadPicture()
    General!GrafGiros.ForeColor = 0
    General!GrafGiros.BackColor = RGB(255, 255, 255)
    General!GrafNormales.Picture = LoadPicture()
    General!GrafNormales.ForeColor = 0
    General!GrafNormales.BackColor = RGB(255, 255, 255)
    General!GrafFlectores.Picture = LoadPicture()
    General!GrafFlectores.ForeColor = 0
    General!GrafFlectores.BackColor = RGB(255, 255, 255)
    General!GrafCortantes.Picture = LoadPicture()
    General!GrafCortantes.ForeColor = 0
    General!GrafCortantes.BackColor = RGB(255, 255, 255)
    General!GrafDeflexiones.Picture = LoadPicture()
    General!GrafDeflexiones.ForeColor = 0
    General!GrafDeflexiones.BackColor = RGB(255, 255, 255)
    
    'Ocultamos los criterios de signos
    General!SignoN.Visible = False
    General!SignoC.Visible = False
    General!SignoM.Visible = False
    General!SignoG.Visible = False
    General!SignoD.Visible = False
    
    'Damos al formulario la escala por defecto
    General.Scale

    'Descargamos todos los apoyos que hubiera en GrafCargas
    For I = 1 To Val(General!Apoyo(0).Tag)
	Unload General!Apoyo(I)
    Next I
    General!Apoyo(0).Tag = "0"

    'Vaciamos la lista de Barras
    For I = 0 To General!ListaBarras.ListCount - 1
	General!ListaBarras.RemoveItem 0
    Next I
    'Desactivamos la caja de abscisas
    General!Label1.ForeColor = GrisO: General!Label2.ForeColor = GrisO
    General!ActualX.Text = "": General!IncrementoX.Text = ""
    General!ActualX.Enabled = False: General!Spin1.Enabled = False
    General!IncrementoX.Enabled = False: General!Spin1.ForeColor = GrisO
    
    'Repartimos las cajas en el formulario
    DivideFormulario
    
    'Desactivamos el botn de inicio, el de ver los valores e imprimir
    General!BotonInicio.Picture = General!BINno.Picture
    General!BINno.Tag = "SI"
    General!OpcionInicio.Enabled = False
    General!BotonValores.Picture = General!BVno.Picture
    General!BVno.Tag = "SI"
    General!OpcionValores.Enabled = False
    General!BotonImprimir.Picture = General!BIno.Picture
    General!BIno.Tag = "SI"
    General!ArchivoImprimir.Enabled = False
    'Deseleccionamos todas las opciones del men Ver
    General!VerCargas.Checked = False
    General!VerNormales.Checked = False
    General!VerCortantes.Checked = False
    General!VerFlectores.Checked = False
    General!VerGiros.Checked = False
    General!VerDeflexiones.Checked = False
    
    'Ponemos a cero los puntos de la abscisa mvil
    XpA = 0: YpA = 0: XqA = 0: YqA = 0
    XpN = 0: YpN = 0: XqN = 0: YqN = 0
    'Ocultamos el formulario Valores
    If FormValores.Visible Then
	ActualizaAbscisa
    End If
    
    'Dejamos el nombre de fichero por defecto
    General.Caption = Left$(General.Caption, 11) & "NONOMBRE.UBU"

    'Dejamos la propiedad .Tag del formulario lista para recibir cambios
    General.Tag = ""

End Sub

Sub ImprimeImagen (X As Integer, Y As Integer)
    Dim hmDC As Integer, hBitMap As Integer, ErrorAPI As Integer
    Const SRCCOPY = &HCC0020    'destino = origen
    Const PIXEL = 3

    'Handle para identificar la imagen
    General!ApoyoImprimir.Picture = General!ApoyoImprimir.Image
    
    'Lo anterior no funciona, si trasladamos al portapapeles la prop. Picture
    'con Clipboard.Setdata General!ApoyoImprimir.Picture, vemos que en el
    'portapapeles no hay ninguna imagen.
    
    'La funcin StretchBlt requiere coordenadas en pixels
    General!ApoyoImprimir.ScaleMode = PIXEL
    Printer.ScaleMode = PIXEL

    hmDC = CreateCompatibleDC(General!ApoyoImprimir.hDC)
    hBitMap = SelectObject(hmDC, General!ApoyoImprimir.Picture)

    'Colocar en el destino la imagen
    ErrorAPI = StretchBlt(Printer.hDC, X, Y, General!ApoyoImprimir.Width * 5, General!ApoyoImprimir.Height * 5, hmDC, 0, 0, General!ApoyoImprimir.ScaleWidth, General!ApoyoImprimir.ScaleHeight, SRCCOPY)
    
    hBitMap = SelectObject(hmDC, hBitMap)
    ErrorAPI = DeleteDC(hmDC)
    
    'Con slo esto, debiera funcionar, pero no se imprime si no se aade
    'un Printer.NewPage
    
End Sub

Function IncrementoLongBarra (XBarra As Single, iba As Integer, NudoI As Integer, NudoJ As Integer)
    'Calcula el incremento de longitud de la barra 'iba' en el pto XBarra
    
    Dim Xi As Single, Xj As Single, Yi As Single, Yj As Single
    Dim ViejaL As Single, NuevaL As Single
    Dim IncrementoL As Single, Incr As Single
    
    ViejaL = Sqr((X(NudoJ) - X(NudoI)) ^ 2 + (Y(NudoJ) - Y(NudoI)) ^ 2)
    Xi = X(NudoI) + Movimientos(NudoI, 1)
    Xj = X(NudoJ) + Movimientos(NudoJ, 1)
    Yi = Y(NudoI) + Movimientos(NudoI, 2)
    Yj = Y(NudoJ) + Movimientos(NudoJ, 2)
    NuevaL = Sqr((Xj - Xi) ^ 2 + (Yj - Yi) ^ 2)
    IncrementoL = NuevaL - ViejaL
    Incr = XBarra * IncrementoL / ViejaL

    IncrementoLongBarra = Incr

End Function

Sub LlenaCargaBarras (NOrdenBarra As Integer)
    Dim Pos As Integer, Ini As Integer, Nbar As Integer, I As Integer
    Dim NCargasB As Single, J As Integer

    Open Mid$(General.Caption, 12) For Binary As #1
    Get #1, 17, Nbar
    'Nos situamos al inicio de las cargas de barras, lo 1 que hay es el n
    'de barras cargadas
    Get #1, 11, Pos
    Seek #1, Pos
    Get #1, , Pos
    ReDim CargaB(0)
    'Si el n de cargas es 0, terminamos
    If Pos = 0 Then
	Close #1
	Exit Sub
    End If
    For I = 1 To Nbar
	'El n de cargas de la barra es
	Get #1, , NCargasB
	If NCargasB = 0 And I = NOrdenBarra Then
	    'Si la barra actualmente seleccionada no tiene cargas en la barra
	    'terminamos
	    Close #1
	    Exit Sub
	ElseIf NCargasB <> 0 And I = NOrdenBarra Then
	    'Si la barra tiene cargas, dimensionamos la matrz de cargas (hay
	    'cinco elementos por cada carga) y ponemos el n de cargas en el
	    'elemento 0 de la matrz
	    ReDim CargaB(NCargasB * 5)
	    CargaB(0) = NCargasB
	    'Llenamos la matrz
	    For J = 1 To NCargasB
		'El orden de los componentes es: valor de la carga, long. A,
		'Lond. B, ngulo y tipo
		Get #1, , NCargasB
		CargaB((J - 1) * 5 + 1) = NCargasB
		Get #1, , NCargasB
		CargaB((J - 1) * 5 + 2) = NCargasB
		Get #1, , NCargasB
		CargaB((J - 1) * 5 + 3) = NCargasB
		Get #1, , NCargasB
		CargaB((J - 1) * 5 + 4) = NCargasB
		Get #1, , NCargasB
		CargaB((J - 1) * 5 + 5) = NCargasB
	    Next J
	    'Terminamos
	    Exit For
	ElseIf NCargasB <> 0 And I <> NOrdenBarra Then
	    'Si la barra est cargada, pero no es actual, avanzamos las
	    'posiciones necesarias hasta la siguiente barra
	    Pos = Seek(1)
	    Seek #1, Pos + NCargasB * 4 * 5
	End If
    Next I
    
    Close #1

End Sub

Sub LlenaCargaNudos ()
    Dim Ini As Integer, Pos As Integer, NNud As Single, I As Integer
    
    Open Mid$(General.Caption, 12) For Binary As #1
    
    Get #1, 1, Ini
    Ini = Ini - 1
    'Tomamos la barra, empiezan en la posicin 27 relativa a Ini y cada
    'una ocupa 28 by
    Pos = Ini + 27 + (General!ListaBarras.ListIndex - 1) * 28
    Get #1, Pos, Barra(1)
    'Colocamos el puntero del archivo al inicio de las cargas en nudos
    Get #1, 9, Pos
    Seek #1, Pos
    'Lo 1 que hay es el n de nudos cargados
    Get #1, , Pos
    'Si el n de cargas es 0, terminamos
    If Pos = 0 Then
	ReDim CargaN(0)
	Close #1
	Exit Sub
    End If
    ReDim CargaN(6)
    For I = 1 To Pos
	Get #1, , NNud
	If CInt(NNud) = Barra(1).NudoI Then
	    'Si el nudo i tiene carga, sumamos 1 al ndice de CargasN, de
	    'modo que si en l hay un 1 sabemos que est cargado este nudo
	    'si es un 2, ser el j y si es un tres, los dos nudos
	    CargaN(0) = CargaN(0) + 1
	    Get #1, , CargaN(1)
	    Get #1, , CargaN(2)
	    Get #1, , CargaN(3)
	ElseIf CInt(NNud) = Barra(1).NudoJ Then
	    CargaN(0) = CargaN(0) + 2
	    Get #1, , CargaN(4)
	    Get #1, , CargaN(5)
	    Get #1, , CargaN(6)
	Else
	    'En caso de que el nudo no pertenezca a la barra, ponemos el
	    'puntero en el inicio del siguiente nudo
	    Seek #1, Seek(1) + 12
	End If
    Next I

    Close #1

End Sub

Sub LlenaListaBarras (Fichero As String)
    Dim Pos As Integer, Ini As Integer, Nbar As Integer
    Dim rl As Single, Num As String
    Dim NudosBarras() As String, NudosI() As Integer, NudosJ() As Integer
    Dim I As Integer, J As Integer, K As Integer, L As Integer, M As Integer
    
    'Abrimos el fichero y obtenemos las barras
    Open Fichero For Binary As #1
    'Inicio de los datos de dibujo
    Get #1, 1, Ini
    Ini = Ini - 1
    'N de barras
    Get #1, 17, Nbar

    'Unidades de trazado de la estructura
    UdsLong = " "
    UdsFuer = " "
    Get #1, Ini + 15, UdsLong
    Get #1, Ini + 16, UdsFuer
    'Ponemos las unidades en FormValores
    ActualizaUnidades
    
    ReDim MatrizLongitudes(Nbar)
    ReDim NudosI(Nbar)
    For I = 1 To Nbar
	'Tomamos la barra, empiezan en la posicin 27 relativa a Ini y cada
	'una ocupa 28 by
	Pos = Ini + 27 + (I - 1) * 28
	Get #1, Pos, Barra(I)
	'Si no se ha numerado algn nudo, generamos un error
	If Barra(I).NudoI = 0 Or Barra(I).NudoJ = 0 Then
	    MsgError = "Queda algn nudo por numerar"
	    Erase Barra: Erase NudosI
	    Barra(I).NudoI = 1 / 0
	End If
	NudosI(I) = Barra(I).NudoI
	'Guardamos la longitud de la barra
	rl = Sqr((Barra(I).Xj - Barra(I).Xi) ^ 2 + (Barra(I).Yj - Barra(I).Yi) ^ 2)
	'Formatemos la longitud para que solo contenga hasta cm.
	Num = LTrim$(Str$(rl))
	Formatea Num
	MatrizLongitudes(I) = Val(Num)
    Next I

    Close #1
    
    'Llenamos la lista de barras
    ReDim NudosBarras(Nbar)
    'Ordenamos la matrz
    OrdenarInteger NudosI()
    'Ordenamos las barras de acuerdo a la numeracin del nudo i y el j
    L = 1
    For I = 1 To Nbar
	K = 0
	For J = 1 To Nbar
	    'Miramos si para un nudo I hay varios J
	    If NudosI(I) = Barra(J).NudoI Then
		K = K + 1
		ReDim Preserve NudosJ(K)
		'NudosJ() contiene todos los J del nudo I
		NudosJ(K) = Barra(J).NudoJ
	    End If
	Next J
	OrdenarInteger NudosJ()
	J = 0
	For M = L To L + K - 1
	    J = J + 1
	    NudosBarras(M) = LTrim$(Str$(NudosI(I))) & "-" & LTrim(Str$(NudosJ(J)))
	Next M
	L = L + K
	I = I + K - 1
	Erase NudosJ
    Next I
    
    'En 1 lugar siempre ponemos toda la estructura
    General!ListaBarras.AddItem "Todas"
    For I = 1 To Nbar
	General!ListaBarras.AddItem NudosBarras(I)
    Next I
    
    Erase NudosI: Erase NudosBarras: Erase Barra

End Sub

Function MaximaCarga (Carga As String)
    Dim Maxima As Single, Pos As Integer, CadN As String
    Dim Nombre As String, CargaP1 As String, CargaP2 As String

    Maxima = 0
    Do
	'Hallamos el final de la carga actual
	Pos = InStr(1, Carga, "/")
	'Obtenemos la carga actual y se la quitamos a la cadena general
	CadN = Left$(Carga, Pos - 1)
	Carga = Mid$(Carga, Pos + 1)
	'Miramos que no sea un flector, que no influyen
	If Left$(CadN, 1) <> "M" Then
	    'Obtenemos el nombre y las cargas
	    Pos = InStr(1, CadN, " ")
	    Nombre = Left$(CadN, Pos - 1)
	    CadN = Mid$(CadN, Pos + 1)
	    
	    Pos = InStr(1, CadN, " ")
	    CargaP1 = Left$(CadN, Pos - 1)
	    CadN = Mid$(CadN, Pos + 1)
	    
	    Pos = InStr(1, CadN, " ")
	    CargaP2 = Left$(CadN, Pos - 1)
	    CadN = Mid$(CadN, Pos + 1)
	    
	    If Val(CargaP1) > Maxima Then Maxima = Val(CargaP1)
	    If Val(CargaP2) > Maxima Then Maxima = Val(CargaP2)
	End If
    Loop Until Len(Carga) = 0

    MaximaCarga = Maxima

End Function

Sub OrdenarInteger (a%())
    Dim NumDeEntradas%, Incremen%, I%, J%, Temp%

    NumDeEntradas% = UBound(a%)
    Incremen% = NumDeEntradas% \ 2
    Do Until Incremen% < 1
	For I% = Incremen% + 1 To NumDeEntradas%
	    Temp% = a%(I%)
	    For J% = I% - Incremen% To 1 Step -Incremen%
		If Temp% >= a%(J%) Then Exit For
		a%(J% + Incremen%) = a%(J%)
	    Next J%
	    a%(J% + Incremen%) = Temp%
	Next I%
	Incremen% = Incremen% \ 2
    Loop

End Sub

Sub OrdenarShell (a$())
    Dim NumDeEntradas%, Incremen%, I%, J%, Temp$

    NumDeEntradas% = UBound(a$)
    Incremen% = NumDeEntradas% \ 2
    Do Until Incremen% < 1
	For I% = Incremen% + 1 To NumDeEntradas%
	    Temp$ = a$(I%)
	    For J% = I% - Incremen% To 1 Step -Incremen%
		If Temp$ >= a$(J%) Then Exit For
		a$(J% + Incremen%) = a$(J%)
	    Next J%
	    a$(J% + Incremen%) = Temp$
	Next I%
	Incremen% = Incremen% \ 2
    Loop

End Sub

Sub PonDibujoApoyo (X As Single, Y As Single, Ancho As Single, Alto As Single, Apo As Image)
    'Calcula las coordenadas del pto. superior izquierdo del control Apo
    'en funcin del ancho y el alto del n del nudo y de las coordenadas
    'X, Y del nudo, las coordenadas las deja en X e Y
    
    Dim Dibujo As String
    Dim Tes1 As Integer, Tes2 As Integer
    
    Ancho = Ancho / 2
    Alto = Alto / 2

    'Calculamos la posicin de la esquina superior izquierda de la figura del
    'apoyo en funcin de Ancho, Alto y de las dimensiones propias de la
    'figura del apoyo a colocar
    Dibujo = Apo.Tag
    Tes1 = Dibujo = "Ca" Or Dibujo = "Cas" Or Dibujo = "Ro" Or Dibujo = "Ros"
    Tes1 = Tes1 Or Dibujo = "Em" Or Dibujo = "Ems"
    Tes2 = Dibujo = "CaI" Or Dibujo = "CaIs" Or Dibujo = "RoI" Or Dibujo = "RoIs"
    Tes2 = Tes2 Or Dibujo = "EmI" Or Dibujo = "EmIs"
    If Tes1 Then
	'En caso de que sea el carro, rtula o empotramiento en la posicin
	'abajo (o sus figuras con el color de seleccionados)
	X = X - Apo.Width / 2
	Y = Y - Alto
    'Si las figuras son con el apoyo en la izda
    ElseIf Tes2 Then
	X = X - Ancho - Apo.Width
	Y = Y + Apo.Height / 2
    'Con el apoyo en la derecha
    Else
	X = X + Ancho
	Y = Y + Apo.Height / 2
    End If
    
End Sub

Function ProcesaError (NError As Integer)
    Dim Msg As String, TipMsg As Integer, Respuesta As Integer
    
    Select Case NError
	Case 57: Msg = "Error de Entrada-Salida": TipMsg = 0
	Case 61: Msg = "Disco lleno": TipMsg = 0
	Case 64: Msg = "Nombre no vlido": TipMsg = 5
	Case 67: Msg = "Demasiados archivos abiertos": TipMsg = 0
	Case 68: Msg = "Verifique la unidad": TipMsg = 5
	Case 70: Msg = "Archivo protegido": TipMsg = 0
	Case 71: Msg = "Unidad no preparada": TipMsg = 5
	Case 72: Msg = "Error en la superficie del disco": TipMsg = 0
	Case 76: Msg = "Va de acceso no encontrada": TipMsg = 5
	Case 482: Msg = "Error de impresora": TipMsg = 5
	Case Else
	    Msg = "Se ha producido un error que impide continuar": TipMsg = 0
    End Select

    Respuesta = MsgBox(Msg, TipMsg, "Error!")

    Select Case Respuesta
	Case 4: ProcesaError = True
	Case Else
	    Close
    End Select

End Function

Sub RenuevaActualX (Num As String)
    Dim Incr As Single, Valor As Single
	    
    'Formateamos el valor introducido para que tenga dos decimales en caso de
    'que las uds. sean m. o ninguno si son cm.
    Formatea Num
    Valor = Val(Num)
    If Valor > MatrizLongitudes(General!ListaBarras.ListIndex) Then
	'Si la abscisa entrada es mayor que la longitud de la viga
	Valor = MatrizLongitudes(General!ListaBarras.ListIndex)
    ElseIf Valor < 0 Then
	'Si es negativo
	Valor = 0
    End If
    General!ActualX.Text = LTrim(Str$(Valor))
    General!ActualX.Tag = General!ActualX.Text
    'Dibujamos la lnea en todas las cajas
    CalculaAbscisa
    'Actualizamos las cifras del formulario Valores
    ActualizaValores

End Sub

Function VerificaInput (Caja As TextBox)
    Dim Msg As String, I As Integer, Actual As Integer
    Dim Num As String, NumText As String, PtoDecimal As Integer
    Dim Exponente As Integer, Pos As Integer, CaD As String
    
    NumText = Trim$(Caja.Text)
    If Len(NumText) > 0 Then
	CaD = NumText
	For I = 1 To Len(NumText)
	    Actual = Asc(Left$(CaD, 1))
	    CaD = Mid$(CaD, 2)
	    Select Case Actual
		Case Asc("0") To Asc("9")
		    Num = Num + Chr$(Actual)
		Case Asc(".") And Not PtoDecimal
		    Num = Num + Chr$(Actual)
		    PtoDecimal = True
		Case Asc(",") And Not PtoDecimal
		    Num = Num + "."
		    PtoDecimal = True
		'Permitimos la entrada de ngulos negativos en las cargas
		Case Asc("-") And I = 1 And Caja.Tag = "Ang"
		    Num = Num + Chr$(Actual)
		'Permitimimos la notacin cientfica en el mdulo de Young
		Case Asc("E") And Not Exponente And Caja.Tag = "Young"
		    Num = Num + Chr$(Actual)
		    Exponente = True
		    Pos = I + 1
		Case Asc("e") And Not Exponente And Caja.Tag = "Young"
		    Num = Num + "E"
		    Exponente = True
		    Pos = I + 1
		'Permitimos la entrada de exponentes positivos en Young
		Case Asc("+") And Exponente And I = Pos And Caja.Tag = "Young"
		    Num = Num + Chr$(Actual)
		Case Else
		    Msg = "Caracter no vlido"
		    MsgBox Msg, 48, "Atencin!"
		    Caja.SelStart = I - 1
		    Caja.SelLength = 1
		    Num = "NO"
		    Exit For
	    End Select
	Next I
	If Val(NumText) > 10000000000# And Caja.Tag <> "Young" Then
	    Msg = "Nmero demasiado grande"
	    MsgBox Msg, 48, "Atencin!"
	    Caja.SelStart = 0
	    Caja.SelLength = Len(NumText)
	    Num = "NO"
	End If
    Else
	Num = ""
    End If
    
    VerificaInput = Num

End Function

