Option Base 1
DefInt I-P

Dim Er As String
Dim Nnu As Integer, Nba As Integer, Ndi As Integer
Dim Nsb As Integer, Nec As Integer, Nap As Integer
Dim E As Single

Dim ni() As Integer, nj() As Integer
Dim Area() As Single, Apoyos() As Integer, Coacciones() As Integer
Dim R() As Single, F() As Single

'Matrices de cargas para crear las ecuaciones
Dim CargasTangenciales() As Single, CargasNormales() As Single
Dim CargasMomentos() As Single, NumElementosEcCargas() As Integer

Sub Abscisas ()
    'Lectura abscisas
    
    Seek #1, 41
    For I = 1 To Nnu
        Get #1, , X(I)
    Next I

End Sub

Sub CargaBarras ()
    'Lectura cargas barras y modificacin de trminos independientes

    Dim Nbc As Integer, Nca As Single, iba As Integer
    Dim nri As Single, cti As Single, fli As Single
    Dim nrj As Single, ctj As Single, flj As Single
    Dim dx As Single, dy As Single, rl As Single
    Dim sena As Single, cosa As Single
    Dim ifi As Integer, ifj As Integer
    
    'El Puntero del archivo se encuentra al inicio de las cargas de barras
    'tras haber leido las cargas en nudos
    'Nmero de barras con cargas
    Get #1, , Nbc
    For iba = 1 To Nba
        'Nm. cargas en la barra
        Get #1, , Nca
        If Nca > 0 Then
            nri = 0: cti = 0: fli = 0          'Esfzos empotr. nudo i
            nrj = 0: ctj = 0: flj = 0          'Esfzos empotr. nudo j
            I = ni(iba): J = nj(iba)
            'Filas matriz
            ifi = 3 * (I - 1) + 1: jfi = 3 * (J - 1) + 1
            dx = X(I) - X(J): dy = Y(I) - Y(J)
            rl = Sqr(dx * dx + dy * dy)
            cosa = dx / rl
            sena = dy / rl
            'Clculo esfuerzos empotramientos
            EsfuerzosEmpotr Nca, nri, cti, fli, nrj, ctj, flj, rl, sena, cosa
            'Modificacin de la matrz de trminos independientes
            F(ifi) = F(ifi) - nri * cosa + cti * sena
            F(jfi) = F(jfi) + nrj * cosa - ctj * sena
            F(ifi + 1) = F(ifi + 1) - nri * sena - cti * cosa
            F(jfi + 1) = F(jfi + 1) + nrj * sena + ctj * cosa
            F(ifi + 2) = F(ifi + 2) - fli
            F(jfi + 2) = F(jfi + 2) - flj
        End If
    Next iba

End Sub

Sub CargaNudos ()
    'Lectura cargas nudos y formacin del trmino independiente
    Dim inu As Integer, Nnc As Integer, nn As Single
    
    'Posicin del inicio de las cargas en los nudos
    Get #1, 9, P
    Seek #1, P
    'Nmero de nudos con cargas
    Get #1, , Nnc
    For inu = 1 To Nnc
        'Nudo cargado
        Get #1, , nn
        'Posicin del trmino independiente en el que se colocarn las
        'componentes de la fuerza
        I = 3 * (nn - 1) + 1
        Get #1, , F(I)
        Get #1, , F(I + 1)
        Get #1, , F(I + 2)
    Next inu

End Sub

Sub CreaEcuaciones ()
    Dim Nbc As Integer, iba As Integer, Nca As Single
    Dim dx As Single, dy As Single, rl As Single
    Dim sena As Single, cosa As Single, Num As String
    
    'Posicin del inicio de las cargas en las barras
    Get #1, 11, P
    'Lo 1 que aparece es el n de barras cargadas
    Get #1, P, Nbc
    'Inicializamos las matrices que contendrn los datos de las cargas
    ReDim CargasTangenciales(1 To 3, 1 To 1)
    ReDim CargasNormales(1 To 3, 1 To 1)
    ReDim CargasMomentos(1 To 3, 1 To 1)
    ReDim NumElementosEcCargas(1 To 3, 1 To 1)
    'Recorremos todas las barras para obtener los trminos necesarios para
    'componer sus ecuaciones de cargas
    For iba = 1 To Nba
        Get #1, , Nca
        If Nca > 0 Then
            I = ni(iba): J = nj(iba)
            dx = X(I) - X(J): dy = Y(I) - Y(J)
            rl = Sqr(dx * dx + dy * dy)
            Num = Str$(rl)
            Formatea Num
            rl = Val(Num)
            cosa = dx / rl
            sena = dy / rl
            'Si la barra tiene cargas, obtenemos los trminos de su ecuacin
            'de cargas
            MatrizCargas Nca, sena, cosa, rl
        Else
            'Si no tiene cargas, colocamos cero en el trmino que indica el
            'n de elementos de la ec. de cargas
            P = UBound(NumElementosEcCargas, 2)
            NumElementosEcCargas(1, P) = 0
            NumElementosEcCargas(2, P) = 0
            NumElementosEcCargas(3, P) = 0
            P = P + 1
            ReDim Preserve NumElementosEcCargas(3, 1 To P)
        End If
    Next iba
    
    'Una vez hallados los trminos de las cargas en las barras, hallamos las
    'ecuaciones
    EcuacionNormales
    EcuacionCortantes
    EcuacionFlectores
    EcuacionGiros
    EcuacionDeflexiones
    
    'Eliminamos de memoria las matrices que ya no necesitamos
    Erase ni: Erase nj: Erase Apoyos
    Erase NumElementosEcCargas: Erase CargasTangenciales
    Erase CargasNormales: Erase CargasMomentos

End Sub

Sub DatosGenerales ()
    Dim GeneraError As Integer
    
    Er = "El mdulo de elasticidad es cero"
    Seek #1, 15
    'N.nudos, barr, difmax, Young
    Get #1, , Nnu
    Get #1, , Nba
    Get #1, , Ndi
    Get #1, , E
    If E = 0 Then GeneraError = 1 / 0
    Nec = 3 * Nnu                       'Nm. ecuac.
    Nsb = 3 * (Ndi + 1)                 'ancho de semibanda
    'Matrices de abscisas, ordenadas, nudos i, nudos j
    ReDim X(Nnu), Y(Nnu), ni(Nba), nj(Nba)
    'Matrices de reas e inercias
    ReDim Area(Nba), Inercia(Nba)
    'Matrices de Rigidez y de Cargas
    ReDim R(Nec, Nsb), F(Nec)

End Sub

Sub Director ()
    Dim Fichero As String
    
    On Error GoTo VerError
    
    Fichero = Mid$(General.Caption, 12)

    Open Fichero For Binary As #1
    
    DatosGenerales
    Abscisas
    Ordenadas
    MatrizRigidez
    CargaNudos
    CargaBarras
    IntoduceApoyos
    Solucion
    Resultados
    CreaEcuaciones

    Close #1

    Exit Sub

VerError:
    
    Close
    If Not AbortarCalculo Then
        Screen.MousePointer = 1
        If Er = "" Then Er = "El archivo no tiene la estructura esperada"
        MsgBox Er, 48, "Error en:"
        Er = ""
    End If

    Exit Sub

End Sub

Sub EcuacionCortantes ()
    'Crea la ecuacin de cortantes de todas las barras de la estructura. La
    'ecuacin est formada por trminos de la forma P*<x-A>^N. Se guardarn
    'en la matrz EcNor() en forma de un string para cada barra, tal como:
    ' "A1;N1;P1;A2;N2;P2;...;An;Nn;Pn;"

    Dim Cad As String, Indice As Integer, iba As Integer
    Dim Var As Single, ElementoA As Single, ElementoN As Single
    Dim ElementoP As Single

    ReDim EcCor(1 To Nba): Indice = 1
    For iba = 1 To Nba
        Cad = ""
        'Vemos si hay cortantes en el nudo i, en ese caso lo introducimos en
        'la ec. como una constante: Q*<x-0>^0
        Var = Cortantes(iba, 1)
        If Var <> 0 Then
            Cad = "0;0;" + LTrim(Str$(Var)) + ";"
        End If
        'Vemos si hay cargas Normales en la barra. Las aadimos a la ec.
        n = NumElementosEcCargas(2, iba)
        If n <> 0 Then
            'La matrz de cargas normales contiene todas las cargas de
            'este tipo de la estructura, desde la 1 barra con estas cargas
            'hasta la ltima. Por ello necesitamos el contador Indice que
            'es el puntero de esta matriz y va acumulando las cargas leidas
            'en esta barra
            For I = Indice To Indice + n - 1
                Indice = Indice + 1
                ElementoA = CargasNormales(1, I)
                ElementoN = CargasNormales(2, I)
                ElementoP = CargasNormales(3, I)
                'Integramos la carga para obtener los Cortantes. Para integrar
                'estas funciones:
                'Si N <= 1: P*<x-A>^N -> P*<x-A>^(N+1)
                'Si N >= 1: P*<x-A>^N -> P/(N+1)*<x-A>^(N+1)
                'La cte de integracin es el trmino obtenido de Cortantes()
                'Tenemos en cuenta la ec. diferencial de los cortantes:
                'dV/dX= -q. Por lo que hemos de cambiar de signo a P
                ElementoP = -ElementoP
                ElementoN = ElementoN + 1
                If ElementoN > 1 Then
                    ElementoP = Format(ElementoP / ElementoN, "0.#######")
                End If
                'Aadimos el trmino a la ecuacin de la barra actual
                If ElementoP <> 0 Then
                    Cad = Cad + LTrim(Str$(ElementoA)) + ";" + LTrim(Str$(ElementoN)) + ";" + LTrim(Str$(ElementoP)) + ";"
                End If
            Next I
        End If
        'Colocamos la carga en su matriz
        EcCor(iba) = Cad
    Next iba
    
End Sub

Sub EcuacionDeflexiones ()
    'Crea la ecuacin de deflexiones de todas las barras de la estructura. La
    'ecuacin est formada por trminos de la forma P*<x-A>^N. Se guardarn
    'en la matrz EcDef() en forma de un string para cada barra, tal como:
    ' "A1;N1;P1;A2;N2;P2;...;An;Nn;Pn;"

    Dim Cad As String, iba As Integer
    
    ReDim EcDef(1 To Nba)
    
    For iba = 1 To Nba
        Cad = ""
        'Integramos la ec de giros para obtener la de deflexiones
        If EcGir(iba) <> "" Then
            Integra EcGir(iba), Cad
        End If
        'Colocamos la carga en su matriz
        EcDef(iba) = Cad
    Next iba

End Sub

Sub EcuacionFlectores ()
    'Crea la ecuacin de flectores de todas las barras de la estructura. La
    'ecuacin est formada por trminos de la forma P*<x-A>^N. Se guardarn
    'en la matrz EcFle() en forma de un string tal para cada barra, como:
    ' "A1;N1;P1;A2;N2;P2;...;An;Nn;Pn;"

    Dim Cad As String, Indice As Integer, iba As Integer
    Dim Var As Single, ElementoA As Single, ElementoN As Single
    Dim ElementoP As Single

    ReDim EcFle(1 To Nba): Indice = 1
    For iba = 1 To Nba
        Cad = ""
        'Vemos si hay flectores en el nudo i, en ese caso lo introducimos en
        'la ec. como una constante: M*<x-0>^0
        Var = Flectores(iba, 1)
        If Var <> 0 Then
            Cad = "0;0;" + LTrim(Str$(Var)) + ";"
        End If
        'Integramos la ec de cortantes para obtener la de flectores
        'La cte de integracin es el trmino obtenido de Flectores()
        If EcCor(iba) <> "" Then
            Integra EcCor(iba), Cad
        End If
        'Vemos si hay cargas momentos en la barra. Estas cargas no influyen
        'en la ec. de cortantes, ya que nicamente representan una singularidad
        'en su diagrama (este trmino se presenta porque la accin de un Mto
        'aplicado en un pto., debe producir concentracin de cortantes). Por
        'todo ello, estas cargas no se han tenido en cuenta en la ec. de
        'cortantes pero si han de tenerse en cuenta para la de flectores
        n = NumElementosEcCargas(3, iba)
        If n <> 0 Then
            'La matrz de cargas momentos contiene todas las cargas de
            'este tipo de la estructura, desde la 1 barra con estas cargas
            'hasta la ltima. Por ello necesitamos el contador Indice que
            'es el puntero de esta matriz y va acumulando las cargas leidas
            'en esta barra
            For I = Indice To Indice + n - 1
                Indice = Indice + 1
                ElementoA = CargasMomentos(1, I)
                ElementoN = CargasMomentos(2, I)
                ElementoP = CargasMomentos(3, I)
                'Tenemos en cuenta la ec. diferencial de los flectores:
                'V= dM/dX= d^2M/dX^2= -q (ya que dV/dX=-q)
                'Por lo que hemos de cambiar de signo a P
                ElementoP = -ElementoP
                'Las cargas momento puntual tienen superndice ElementoN=-2
                'por lo que al integrarlas dos veces para obtener la ec. de
                'flectores obtenemos: M*<X-A>^-2 -> M*<X-A>^-1 -> M*<X-A>^0
                'Lo nico que cambia es ElementoN=0
                'Aadimos el trmino a la ecuacin de la barra actual
                If ElementoP <> 0 Then
                    Cad = Cad + LTrim(Str$(ElementoA)) + ";0;" + LTrim(Str$(ElementoP)) + ";"
                End If
            Next I
        End If
        'Colocamos la carga en su matriz
        EcFle(iba) = Cad
    Next iba

End Sub

Sub EcuacionGiros ()
    'Crea la ecuacin de giros de todas las barras de la estructura. La
    'ecuacin est formada por trminos de la forma P*<x-A>^N. Se guardarn
    'en la matrz EcGir() en forma de un string para cada barra, tal como:
    ' "A1;N1;P1;A2;N2;P2;...;An;Nn;Pn;"

    Dim Ec As String, Cad As String, Num As Single, iba As Integer
    Dim ElementoA As Single, ElementoN As Single, ElementoP As Single
    Dim Var As Single

    'Obtenemos la matriz de rigideces multiplicando E*I
    For iba = 1 To Nba
        Inercia(iba) = Inercia(iba) * E
    Next iba
    
    ReDim EcGir(1 To Nba)
    For iba = 1 To Nba
        Cad = "": Var = 0: Ec = ""
        'Vemos si hay giros en el nudo i, en ese caso lo introducimos en
        'la ec. como una constante: G(i)*E*I*<x-0>^0 (los giros (+) son los
        'horarios, el criterio con que estn guardados en Movimientos)
        Var = Movimientos(ni(iba), 3)
        If Var <> 0 Then
            Var = Format(Var * Inercia(iba), "0.#######")
            EcGir(iba) = "0;0;" + LTrim(Str$(Var)) + ";"
        End If
        'Ya que la ec. diferencial de los giros es:
        'E*I*d^2(Y)/dX^2= E*I*d(Giro)/dX= -M
        'hemos de cambiar el signo a la ec de flectores antes de integrarla
        'para obtener la ec. de giros.
        If EcFle(iba) <> "" Then
            Ec = EcFle(iba)
            Do
                ElementoA = Val(Ec)
                P = InStr(1, Ec, ";")
                Ec = Mid$(Ec, P + 1)
                ElementoN = Val(Ec)
                P = InStr(1, Ec, ";")
                Ec = Mid$(Ec, P + 1)
                'Cambiamos el signo
                ElementoP = -Val(Ec)
                P = InStr(1, Ec, ";")
                Ec = Mid$(Ec, P + 1)
                Cad = Cad + LTrim(Str$(ElementoA)) + ";" + LTrim(Str$(ElementoN)) + ";" + LTrim(Str$(ElementoP)) + ";"
            Loop Until Ec = ""
            Integra Cad, Ec
        End If
        'La cte. de integracin es la proveniente de Movimientos .Colocamos
        'la carga en su matriz
        EcGir(iba) = EcGir(iba) + Ec
    Next iba
    
End Sub

Sub EcuacionNormales ()
    'Crea la ecuacin de Normales de todas las barras de la estructura. La
    'ecuacin est formada por trminos de la forma P*<x-A>^N. Se guardarn
    'en la matrz EcNor() en forma de un string para cada barra,tal como:
    ' "A1;N1;P1;A2;N2;P2;...;An;Nn;Pn;"

    Dim Cad As String, Indice As Integer, iba As Integer
    Dim Var As Single, ElementoA As Single, ElementoN As Single
    Dim ElementoP As Single

    ReDim EcNor(1 To Nba): Indice = 1
    For iba = 1 To Nba
        Cad = ""
        'Vemos si hay normales en el nudo i, en ese caso lo introducimos en
        'la ec. como una constante: N*<x-0>^0
        Var = Normales(iba, 1)
        If Var <> 0 Then
            Cad = "0;0;" + LTrim(Str$(Var)) + ";"
        End If
        'Vemos si hay cargas tangenciales en la barra. Las aadimos a la ec.
        n = NumElementosEcCargas(1, iba)
        If n <> 0 Then
            'La matrz de cargas tangenciales contiene todas las cargas de
            'este tipo de la estructura, desde la 1 barra con estas cargas
            'hasta la ltima. Por ello necesitamos el contador Indice que
            'es el puntero de esta matriz y va acumulando las cargas leidas
            'en esta barra
            For I = Indice To Indice + n - 1
                Indice = Indice + 1
                ElementoA = CargasTangenciales(1, I)
                ElementoN = CargasTangenciales(2, I)
                ElementoP = CargasTangenciales(3, I)
                'Integramos la carga para obtener los Normales. Para integrar
                'estas funciones:
                'Si N <= 1: P*<x-A>^N -> P*<x-A>^(N+1)
                'Si N >= 1: P*<x-A>^N -> P/(N+1)*<x-A>^(N+1)
                'La cte de integracin es el trmino obtenido de Normales()
                'Tenemos en cuenta la ec. diferencial de los normales:
                'dN/dX= -q. Por lo que hemos de cambiar de signo a P
                ElementoP = -ElementoP
                ElementoN = ElementoN + 1
                If ElementoN > 1 Then
                    ElementoP = Format(ElementoP / ElementoN, "0.#######")
                End If
                'Aadimos el trmino a la ecuacin de la barra actual
                If ElementoP <> 0 Then
                    Cad = Cad + LTrim(Str$(ElementoA)) + ";" + LTrim(Str$(ElementoN)) + ";" + LTrim(Str$(ElementoP)) + ";"
                End If
            Next I
        End If
        'Colocamos la carga en su matriz
        EcNor(iba) = RTrim(Cad)
    Next iba

End Sub

Sub EsfuerzosEmpotr (Nca As Single, nri As Single, cti As Single, fli As Single, nrj As Single, ctj As Single, flj As Single, rl As Single, sena As Single, cosa As Single)
    'Clculo de esf. de empotramiento en una barra

    Dim ica As Integer, P As Single, a As Single, B As Single
    Dim Tseta As Single, Tipo As Single, sent As Single, cost As Single
    Dim Pn As Single, Pt As Single, al As Single, bL As Single
    Dim c As Single, amc As Single, a2 As Single, C2 As Single
    Dim ca3 As Single, ca4 As Single, Pdl2 As Single, dif As Single
    Dim a1 As Single, a3 As Single, Pb As Single
    
    For ica = 1 To Nca
       Get #1, , P
       Get #1, , a
       Get #1, , B
       Get #1, , Tseta
       Get #1, , Tipo
       sent = Sin(Tseta * PI / 180)
       cost = Cos(Tseta * PI / 180)
       If Abs(sent) < .001 Then sent = 0
       If Abs(cost) < .001 Then cost = 0
       Pn = P * (cost * sena - sent * cosa)         'Componente normal
       Pt = -P * (sent * sena + cost * cosa)        'Comp. tangencial
       'Carga puntual
       If Tipo = 1 Then
          al = a / rl
          nri = nri + Pt * (1 - al)               'Normal i
          nrj = nrj - Pt * al                     'Normal j
          bL = (3 - 2 * al) * al * al
          cti = cti + Pn * (1 - bL)               'Cortante i
          ctj = ctj - Pn * bL                     'Cortante j
          al = 1 - al
          fli = fli + Pn * al * al * a            'Momento i
          flj = flj - Pn * al * a * a / rl        'Momento j
       'Carga repartida
       ElseIf Tipo = 2 Then
          c = a + B: amc = (a + c) / 2 / rl
          nri = nri + Pt * B * (1 - amc)
          nrj = nrj - Pt * B * amc
          C2 = c * c: a2 = a * a
          ca3 = C2 * c - a2 * a
          ca4 = C2 * C2 - a2 * a2
          Pdl2 = Pn / 2 / rl / rl
          dif = ca4 / rl - 2 * ca3
          cti = cti + Pdl2 * (2 * B * rl * rl + dif)
          ctj = ctj + Pdl2 * dif
          ca4 = ca4 * 3 / rl / rl
          fli = fli + Pn * (6 * (C2 - a2) + ca4 - 8 * ca3 / rl) / 12
          flj = flj + Pn * (ca4 - 4 * ca3 / rl) / 12
       'Carga triangular de pendiente positiva
       ElseIf Tipo = 3 Then
          a = rl - a - B: a1 = a + B
          a2 = (2 * a + a1) / (3 * rl)
          nri = nri + Pt * B / 2 * (1 - a2)
          nrj = nrj - Pt * B / 2 * a2
          a2 = (a1 * a1 + 2 * a1 * a + 3 * a * a) / rl
          a3 = (a1 * a1 * a1 + 2 * a1 * a1 * a + 3 * a1 * a * a + 4 * a * a * a) / rl / rl
          Pb = Pn * B / (20 * rl)
          cti = cti + Pb * (5 * a2 - 2 * a3)
          ctj = ctj - Pb * (-5 * a2 + 10 * rl + 2 * a3)
          Pb = Pn * B / 60
          fli = fli + Pb * (5 * a2 - 3 * a3)
          flj = flj - Pb * (3 * a3 + 10 * (a1 + 2 * a) - 10 * a2)
       'Carga triangular de pendiente negativa
       ElseIf Tipo = -3 Then
          a1 = a + B
          a2 = (2 * a + a1) / (3 * rl)
          nri = nri + Pt * B / 2 * a2
          nrj = nrj - Pt * B / 2 * (1 - a2)
          a2 = (a1 * a1 + 2 * a1 * a + 3 * a * a) / rl
          a3 = (a1 * a1 * a1 + 2 * a1 * a1 * a + 3 * a1 * a * a + 4 * a * a * a) / rl / rl
          Pb = Pn * B / (20 * rl)
          cti = cti + Pb * (-5 * a2 + 10 * rl + 2 * a3)
          ctj = ctj - Pb * (5 * a2 - 2 * a3)
          Pb = Pn * B / 60
          fli = fli + Pb * (3 * a3 + 10 * (a1 + 2 * a) - 10 * a2)
          flj = flj - Pb * (5 * a2 - 3 * a3)
       'Momento puntual
       ElseIf Tipo = 4 Then
          al = a / rl
          nri = 0: nrj = 0
          a1 = P * 6 * a / rl / rl * (1 - al)
          cti = cti + a1
          ctj = ctj + a1
          fli = fli - P * (1 - al * (4 - 3 * al))
          flj = flj + P * al * (2 - 3 * al)
       End If
   Next ica
       
End Sub

Sub Integra (ByVal Ec As String, Cad As String)
    'Integra la ecuacin Ec y guarda el resultado en Cad. Para integrar estas
    'funciones de discontinuidad:
    'Si N <= 1: P*<x-A>^N -> P*<x-A>^(N+1)
    'Si N >= 1: P*<x-A>^N -> P/(N+1)*<x-A>^(N+1)
    
    Dim ElementoA As Single, ElementoN As Single, ElementoP As Single
    
    Do
        'Obtenemos cada trmino
        ElementoA = Val(Ec)
        P = InStr(1, Ec, ";")
        Ec = Mid$(Ec, P + 1)

        ElementoN = Val(Ec)
        P = InStr(1, Ec, ";")
        Ec = Mid$(Ec, P + 1)
            
        ElementoP = Val(Ec)
        P = InStr(1, Ec, ";")
        Ec = Mid$(Ec, P + 1)
        'Lo integramos
        ElementoN = ElementoN + 1
        If ElementoN > 1 Then
            ElementoP = ElementoP / ElementoN
        End If
        ElementoP = Format(ElementoP, "0.#######")
        'Aadimos el nuevo trmino a la nueva ecuacin
        If ElementoP <> 0 Then
            Cad = Cad + LTrim(Str$(ElementoA)) + ";" + LTrim(Str$(ElementoN)) + ";" + LTrim(Str$(ElementoP)) + ";"
        End If
    Loop Until Ec = ""
     
End Sub

Sub IntoduceApoyos ()
    'Lectura def. apoyos y modificacin de la matriz de rigidez
    Dim iap As Integer, na As Integer, cx As Integer
    Dim cy As Integer, cz As Integer

    'Nm. de apoyos
    Get #1, , Nap
    ReDim Apoyos(1 To 4, 1 To Nap)
    For iap = 1 To Nap
        'Nudo apoyo y coaccin
        Get #1, , na
        Get #1, , cx
        Get #1, , cy
        Get #1, , cz
        Apoyos(1, iap) = na: Apoyos(2, iap) = cx
        Apoyos(3, iap) = cy: Apoyos(4, iap) = cz:
        'Filas a modificar
        I = 3 * (na - 1) + 1
        J = I + 1
        k = I + 2
        If cx = 0 Then R(I, 1) = 1E+20
        If cy = 0 Then R(J, 1) = 1E+20
        If cz = 0 Then R(k, 1) = 1E+20
    Next iap

End Sub

Sub LlenaCargas (matriz() As Single, a As Single, n As Integer, P As Single)
    Dim Pos As Integer

    Pos = UBound(matriz, 2)
    
    matriz(1, Pos) = a
    matriz(2, Pos) = n
    matriz(3, Pos) = Format(P, "0.#######")

    Pos = Pos + 1
    ReDim Preserve matriz(3, 1 To Pos)

End Sub

Sub MatrizCargas (Nca As Single, sena As Single, cosa As Single, L As Single)

    Dim ica As Integer, P As Single, a As Single, B As Single
    Dim Tseta As Single, Tipo As Single, sent As Single, cost As Single
    Dim Pn As Single, Pt As Single, Normales As Integer, Cortantes As Integer
    Dim Momentos As Integer
    
    For ica = 1 To Nca
        Get #1, , P
        Get #1, , a
        Get #1, , B
        Get #1, , Tseta
        Get #1, , Tipo
        sent = Sin(Tseta * PI / 180)
        cost = Cos(Tseta * PI / 180)
        If Abs(sent) < .001 Then sent = 0
        If Abs(cost) < .001 Then cost = 0
        Pn = -P * (cost * sena - sent * cosa)         'Componente normal
        Pt = -P * (sent * sena + cost * cosa)        'Comp. tangencial
        Select Case Tipo
            Case 1
                If Pt <> 0 Then
                    LlenaCargas CargasTangenciales(), a, -1, Pt
                    Tangenciales = Tangenciales + 1
                End If
                If Pn <> 0 Then
                    LlenaCargas CargasNormales(), a, -1, Pn
                    Normales = Normales + 1
                End If
            Case 2
                If Pt <> 0 Then
                    LlenaCargas CargasTangenciales(), a, 0, Pt
                    Tangenciales = Tangenciales + 1
                    If a + B < L Then
                        LlenaCargas CargasTangenciales(), a + B, 0, -Pt
                        Tangenciales = Tangenciales + 1
                    End If
                End If
                If Pn <> 0 Then
                    LlenaCargas CargasNormales(), a, 0, Pn
                    Normales = Normales + 1
                    If a + B < L Then
                        LlenaCargas CargasNormales(), a + B, 0, -Pn
                        Normales = Normales + 1
                    End If
                End If
            Case 3
                If Pt <> 0 Then
                    LlenaCargas CargasTangenciales(), a, 1, Pt / B
                    Tangenciales = Tangenciales + 1
                    If a + B < L Then
                        LlenaCargas CargasTangenciales(), a + B, 1, -Pt / B
                        LlenaCargas CargasTangenciales(), a + B, 0, -Pt
                        Tangenciales = Tangenciales + 2
                    End If
                End If
                If Pn <> 0 Then
                    LlenaCargas CargasNormales(), a, 1, Pn / B
                    Normales = Normales + 1
                    If a + B < L Then
                        LlenaCargas CargasNormales(), a + B, 1, -Pn / B
                        LlenaCargas CargasNormales(), a + B, 0, -Pn
                        Normales = Normales + 2
                    End If
                End If
            Case -3
                If Pt <> 0 Then
                    LlenaCargas CargasTangenciales(), a, 0, Pt
                    LlenaCargas CargasTangenciales(), a, 1, -Pt / B
                    Tangenciales = Tangenciales + 2
                    If a + B < L Then
                        LlenaCargas CargasTangenciales(), a + B, 1, Pt / B
                        Tangenciales = Tangenciales + 1
                    End If
                End If
                If Pn <> 0 Then
                    LlenaCargas CargasNormales(), a, 0, Pn
                    LlenaCargas CargasNormales(), a, 1, -Pn / B
                    Normales = Normales + 2
                    If a + B < L Then
                        LlenaCargas CargasNormales(), a + B, 1, Pn / B
                        Normales = Normales + 1
                    End If
                End If
            Case 4
                LlenaCargas CargasMomentos(), a, -2, -P
                Momentos = Momentos + 1
        End Select
    Next ica

    'La matriz NumElementosEcCargas contiene, para cada barra, el n de
    'elementos que componen las ecuacin de cargas: tangenciales, normales y
    'de momentos
    P = UBound(NumElementosEcCargas, 2)
    NumElementosEcCargas(1, P) = Tangenciales
    NumElementosEcCargas(2, P) = Normales
    NumElementosEcCargas(3, P) = Momentos
    P = P + 1
    ReDim Preserve NumElementosEcCargas(3, 1 To P)
    
End Sub

Sub MatrizRigidez ()
    'Formacin de la matrz de rigidez
    
    Dim GeneraError As Integer, iba As Integer, Barra As Estructura
    Dim Ini As Integer, i1 As Integer, i2 As Integer, i3 As Integer
    Dim j1 As Integer, j2 As Integer, j3 As Integer, jd As Integer
    Dim dx As Single, dy As Single, rl As Single
    Dim sena As Single, cosa As Single, t As Single
    Dim EAL As Single, EIL As Single, EI1 As Single, EI2 As Single
    Dim RCNL As String

    RCNL = Chr$(10) + Chr$(13)
    
    'Inicio de los datos de dibujo
    Get #1, 1, Ini
    'Inicio de las barras
    Ini = Ini + 26
    For iba = 1 To Nba
        'Inicio de la barra actual (cada barra ocupa 28 by)
        P = Ini + (iba - 1) * 28
        'Obtenemos la barra actual
        Get #1, P, Barra
        Er = "Barra " & Barra.Nudoi & "-" & Barra.Nudoj & RCNL & RCNL
        I = Barra.Nudoi
        J = Barra.Nudoj
        If I > J Then
            Er = Er + "La numeracin del nudo 'i' ha"
            Er = Er + " de ser menor que la del 'j'"
            GeneraError = 1 / 0
        End If
        ni(iba) = I: nj(iba) = J
        'Filas modif.nudo i
        i1 = 3 * (I - 1) + 1: i2 = i1 + 1: i3 = i2 + 1
        'Filas modif.nudo j
        j1 = 3 * (J - 1) + 1: j2 = j1 + 1: j3 = j2 + 1
        'Distancia i - j
        jd = 3 * (J - I)
        dx = X(I) - X(J)
        dy = Y(I) - Y(J)
        rl = Sqr(dx * dx + dy * dy)
        cosa = dx / rl
        sena = dy / rl
        'Eltos. para clculo de coefs. de matriz de rigidez
        If Barra.Area = 0 Then
            Er = Er + "La barra no puede tener rea cero"
            GeneraError = 1 / 0
        End If
        Area(iba) = Barra.Area
        Inercia(iba) = Barra.Inercia
        EAL = E * Barra.Area / rl
        EIL = 2 * E * Barra.Inercia / rl
        EI1 = 6 * E * Barra.Inercia / rl / rl
        EI2 = 12 * E * Barra.Inercia / rl / rl / rl
        t = EAL * cosa * cosa + EI2 * sena * sena
        'Aportacin de la barra a la matriz de rigidez
        R(i1, 1) = R(i1, 1) + t
        R(j1, 1) = R(j1, 1) + t
        R(i1, 1 + jd) = -t
        t = (EAL - EI2) * sena * cosa
        R(i1, 2) = R(i1, 2) + t
        R(j1, 2) = R(j1, 2) + t
        R(i1, 2 + jd) = -t: R(i2, jd) = -t
        t = EI1 * sena
        R(i1, 3) = R(i1, 3) - t
        R(j1, 3) = R(j1, 3) + t
        R(i1, 3 + jd) = -t: R(i3, -1 + jd) = t
        t = EAL * sena * sena + EI2 * cosa * cosa
        R(i2, 1) = R(i2, 1) + t
        R(j2, 1) = R(j2, 1) + t
        R(i2, 1 + jd) = -t
        t = EI1 * cosa
        R(i2, 2) = R(i2, 2) + t
        R(j2, 2) = R(j2, 2) - t
        R(i2, 2 + jd) = t: R(i3, jd) = -t
        t = 2 * EIL
        R(i3, 1) = R(i3, 1) + t
        R(j3, 1) = R(j3, 1) + t
        R(i3, 1 + jd) = t / 2
    Next iba
    
End Sub

Sub Ordenadas ()
    'Lectura ordenadas
    
    'Las ordenadas se encuentran al trmino de las abscisas, por lo que el
    'puntero del archivo se encuentra ahora al comienzo de las ordenadas
    For I = 1 To Nnu
        Get #1, , Y(I)
    Next I

End Sub

Sub Resultados ()
    'Clculo y grabacin de resultados
    
    Dim nri As Single, cti As Single, fli As Single
    Dim nrj As Single, ctj As Single, flj As Single
    Dim nrh As Single, cth As Single, fih As Single, fjh As Single
    Dim dx As Single, dy As Single, rl As Single
    Dim sena As Single, cosa As Single, Nca As Single
    Dim ifi As Integer, ifj As Integer, Nbc As Integer
    Dim EAL As Single, EIL As Single, EI1 As Single, EI2 As Single
    Dim c As Single, Fx As Single, Fy As Single, Fz As Single
    Dim inu As Integer, iba As Integer
    
    ReDim Normales(1 To Nba, 1 To 2)
    ReDim Cortantes(1 To Nba, 1 To 2)
    ReDim Flectores(1 To Nba, 1 To 2)
    ReDim Movimientos(1 To Nnu, 1 To 3)
    
    'Guardamos los movimientos con el criterio de signos:
    '          ^
    '        Y |     giros horarios (+)
    '          |
    '          |
    '          ----------> X
    I = 1
    For inu = 1 To Nnu
        Movimientos(inu, 1) = Format(F(I), "0.#####")
        Movimientos(inu, 2) = Format(F(I + 1), "0.#####")
        Movimientos(inu, 3) = Format(F(I + 2), "0.#####")
        I = I + 3
    Next inu
    
    'Posicin del inicio de las cargas en las barras
    Get #1, 11, P
    'Lo 1 que aparece es el n de barras cargadas
    Get #1, P, Nbc
    For iba = 1 To Nba
        nri = 0: cti = 0: fli = 0          'Esfzos empotr. nudo i
        nrj = 0: ctj = 0: flj = 0          'Esfzos empotr. nudo j
        I = ni(iba): J = nj(iba)
        'Filas matriz
        ifi = 3 * (I - 1) + 1: jfi = 3 * (J - 1) + 1
        dx = X(I) - X(J): dy = Y(I) - Y(J)
        rl = Sqr(dx * dx + dy * dy)
        cosa = dx / rl
        sena = dy / rl
        'Coefs. de rigidez
        EAL = E * Area(iba) / rl
        EIL = 2 * E * Inercia(iba) / rl
        EI1 = 6 * E * Inercia(iba) / rl / rl
        EI2 = 12 * E * Inercia(iba) / rl / rl / rl
        Fx = F(jfi) - F(ifi)
        Fy = F(jfi + 1) - F(ifi + 1)
        Fz = F(jfi + 2) + F(ifi + 2)
        c = Fx * sena - Fy * cosa
        'Normal hiperesttico
        nrh = -EAL * (Fx * cosa + Fy * sena)
        'Cortante
        cth = EI2 * c + EI1 * Fz
        'Flector i
        fih = (Fz + F(ifi + 2)) * EIL + c * EI1
        'Flector j
        fjh = (Fz + F(jfi + 2)) * EIL + c * EI1
        If Nbc > 0 Then
          Get #1, , Nca
          EsfuerzosEmpotr Nca, nri, cti, fli, nrj, ctj, flj, rl, sena, cosa
        End If
        nri = nri + nrh: nrj = nrj + nrh
        cti = cti + cth: ctj = ctj + cth
        fli = fli + fih: flj = flj + fjh
        'Guardamos los esfuerzos con el criterio de signos:
        '       ^                     V
        '       |  |--------------|  |
        '   N <-|--|i            j|--|-> N
        '       |  |______________|  |
        '     V                      v
        '  Los flectores positivos son: horarios en i, antihorarios en j
        '
        Normales(iba, 1) = Format(nri, "0.###")
        Normales(iba, 2) = Format(nrj, "0.###")
        Cortantes(iba, 1) = Format(-cti, "0.###")
        Cortantes(iba, 2) = Format(-ctj, "0.###")
        Flectores(iba, 1) = Format(fli, "0.###")
        Flectores(iba, 2) = Format(-flj, "0.###")
    Next iba

    Erase Area: Erase F

End Sub

Sub Solucion ()
    'Resolucin del sistema de ecuaciones

    Dim nfi As Integer, fac As Single, sum As Single
   
    'Triangulacin. La fila i se resta de las siguientes
    For I = 1 To Nec - 1
        For J = 2 To Nsb
            'Fila a la que se resta la i
            nfi = I + J - 1
            If nfi <= Nec And R(I, J) <> 0 Then
                'Factor por que se mult. fila i
                fac = R(I, J) / R(I, 1)
                k = 1
                'Modificacin de la fila de la matrz de rigidez
                For L = J To Nsb
                    R(nfi, k) = R(nfi, k) - fac * R(I, L)
                    k = k + 1
                Next L
                'Modificacin del trmino independiente
                F(nfi) = F(nfi) - fac * F(I)
            End If
        Next J
    Next I
    'Sustitucin hacia atrs
    For I = Nec To 1 Step -1
        sum = 0
        'Sustituimos las incgnitas halladas por sus valores (guardados en
        'los correspondientes trminos independientes)
        For J = 2 To Nsb
            nfi = I + J - 1
            If nfi <= Nec Then sum = sum + R(I, J) * F(nfi)
        Next J
        'Despejamos la incgnita actual
        F(I) = (F(I) - sum) / R(I, 1)
    Next I
    'Eliminamos de memoria la matrz de rigidez
    Erase R

End Sub

Function Valor (ByVal Ec As String, X As Single)
    'Obtiene el valor de la ec. dada en el pto dado
    
    Dim a As Single, n As Single, P As Single, Num As Single, Pos As Integer
    
    Do
        'Obtenemos cada trmino
        a = Val(Ec)
        Pos = InStr(1, Ec, ";")
        Ec = Mid$(Ec, Pos + 1)

        n = Val(Ec)
        Pos = InStr(1, Ec, ";")
        Ec = Mid$(Ec, Pos + 1)
            
        P = Val(Ec)
        Pos = InStr(1, Ec, ";")
        Ec = Mid$(Ec, Pos + 1)

        If X >= a Then
            Num = Num + (X - a) ^ n * P
        End If

    Loop Until Ec = ""

    Valor = Num

End Function

